package com.pjb.springbootjjwt.annotation;

import cn.hutool.core.date.DatePattern;

import javax.validation.Constraint;
import javax.validation.Payload;
import java.lang.annotation.*;

import static java.lang.annotation.RetentionPolicy.RUNTIME;

/**
 * @description:
 * @param: * @param null
 * @return: 
 * @author: Jiay
 * @date: 2022-5-25 13:26
 */
@Documented
@Constraint(validatedBy = com.pjb.springbootjjwt.annotation.DateTimeValueValidator .class)
@Target({ElementType.FIELD, ElementType.PARAMETER})
@Retention(RetentionPolicy.RUNTIME)
public @interface DateTimeValue {

    String message() default "日期时间格式不正确，正确格式应为" + DatePattern.NORM_DATETIME_PATTERN;

    String pattern() default DatePattern.NORM_DATETIME_PATTERN;

    Class[] groups() default {};

    Class<? extends Payload>[] payload() default {};

    @Target({ElementType.FIELD, ElementType.PARAMETER})
    @Retention(RUNTIME)
    @Documented
    @interface List {
        com.pjb.springbootjjwt.annotation.DateTimeValue[] value();
    }
}
