package com.pjb.springbootjjwt.annotation;

import cn.hutool.core.util.StrUtil;

import javax.validation.ConstraintValidator;
import javax.validation.ConstraintValidatorContext;
import java.time.LocalDateTime;
import java.time.format.DateTimeFormatter;

/**
 * @description:
 * @param: * @param null
 * @return: 
 * @author: Jiay
 * @date: 2022-5-25 13:04
 */
public class DateTimeValueValidator implements ConstraintValidator<DateTimeValue, String> {

    private String pattern;

    @Override
    public void initialize(DateTimeValue dateTimeValue) {
        this.pattern = dateTimeValue.pattern();
    }

    @Override
    public boolean isValid(String dateTimeValue, ConstraintValidatorContext context) {
        //为空则放过，因为在此校验之前会加入@NotNull或@NotBlank校验
        if (StrUtil.isBlank(dateTimeValue)) {
            return true;
        }
        //长度不对直接返回
        if (dateTimeValue.length() != pattern.length()) {
            return false;
        }
        try {
            DateTimeFormatter dateTimeFormatter = DateTimeFormatter.ofPattern(pattern);
            LocalDateTime.parse(dateTimeValue, dateTimeFormatter);
            return true;
        } catch (Exception e) {
            return false;
        }
    }
}
