/*============================================================================================================
File description:

Filename: KH_SendJCBZ_To_MES.cxx
Module  :
	KHom006-MES集成：图纸齐套性接口
	MES调用TC接口，根据提供的物料号，TC返回物料号对应的产品图纸和工艺图纸信息
============================================================================================================
DATE           Name             Description of Change
2024-04-12     liujb		    Creation

$HISTORY$
2024-04-12     liujb          Modify：
============================================================================================================*/
package com.pjb.springbootjjwt.api;

import com.pjb.springbootjjwt.entity.ProductDrawingInput;
import com.pjb.springbootjjwt.entity.Result;
import com.pjb.springbootjjwt.entity.input.CompletenessInput;
import com.pjb.springbootjjwt.service.MesService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.ResponseBody;
import org.springframework.web.bind.annotation.RestController;

@RestController
public class MesController {
    @Autowired
    MesService service;
    @PostMapping("/GetProductDrawing")
    @ResponseBody
    public Object getProductDrawing(@RequestBody ProductDrawingInput productDrawingInput){
        Result result = service.getProductDrawingInfo(productDrawingInput);
        return  result;
    }

    @PostMapping("/Completeness")
    @ResponseBody
    public Object getCompleteness(@RequestBody CompletenessInput completenessInput){
        Result result = service.getCompletenessInfo(completenessInput);
        return  result;
    }
}
