package com.pjb.springbootjjwt.utils;


import com.alibaba.fastjson.JSONObject;
import com.google.common.reflect.TypeToken;
import com.google.gson.Gson;
import com.pjb.springbootjjwt.entity.ConfigInfo;
import com.teamcenter.soa.client.model.ModelObject;

import java.io.*;
import java.lang.reflect.InvocationTargetException;
import java.lang.reflect.Method;
import java.lang.reflect.Type;
import java.math.BigDecimal;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.*;

public class CommonlyUtils {
    public static SimpleDateFormat sdf = new SimpleDateFormat ( "yyyy-MM-dd HH:mm:ss" );
    public static SimpleDateFormat sdf2 = new SimpleDateFormat ( "yyyy-MM-dd HH:mm" );
    public static SimpleDateFormat fileNameSDF = new SimpleDateFormat ( "yyyyMMddHHmmss" );
    public static SimpleDateFormat fileNameSDF2 = new SimpleDateFormat ( "yyyyMMddHHmmssSSS" );
    public static SimpleDateFormat sdf_en = new SimpleDateFormat("d-MMM-yyyy HH:mm", Locale.ENGLISH);
    static {
        sdf.setTimeZone(TimeZone.getTimeZone("GMT+8"));
        fileNameSDF.setTimeZone(TimeZone.getTimeZone("GMT+8"));
    }

    public static String getNowDate(){
        return fileNameSDF.format(new Date());
    }

    public static String getNowDate2(){
        return fileNameSDF2.format(new Date());
    }

    public static boolean isEmpty(String str){
        if (str != null && str.length() > 0){
            return false;
        }
        return true;
    }

    public static boolean isEmptyArray(Object[] str){
        if (str != null && str.length > 0){
            return false;
        }
        return true;
    }

    public static boolean isEmpty(ModelObject[] objs) {
        if (objs != null && objs.length > 0) {
            return false;
        }
        return true;
    }

    public static boolean isEmpty(ModelObject obj){
        if (obj != null){
            return false;
        }
        return true;
    }

    public static <T> boolean isEmpty(T t){
        if (t != null){
            return false;
        }
        return true;
    }

    public static <T> boolean isEmptyMap(Map<T,T> objMap){
        if (objMap != null && objMap.size() > 0){
            return false;
        }
        return true;
    }

    public static <T> boolean isEmptyList(List<T> objectList){
        if (objectList != null && objectList.size() > 0){
            return false;
        }
        return true;
    }

    public static Long strToDateLong(String str) throws ParseException {
        if (str.isEmpty()) {
            return null;
        }
        Date date = CommonlyUtils.sdf.parse(str);
        Calendar calendar = Calendar.getInstance();
        calendar.setTime(date);
        Long timestamp = calendar.getTimeInMillis();
        return timestamp;
    }

    //中文日期格式转英文日期格式（TC查询构建器日期需要用英文的）
    public static String toEnTime(String str) throws ParseException {
        if (isEmpty(str)){
            return null;
        }
        return sdf_en.format(sdf.parse(str));
    }

    //获取list的长度
    public static int getLen(List list) {
        if (list == null || list.size() == 0)
            return 0;
        else
            return list.size();
    }

    public static int getLen(Object[] objs) {
        if (objs == null || objs.length == 0)
            return 0;
        else
            return objs.length;
    }

    //两数相乘
    public static String MultiplyNumbers(String arg0, String arg1) {
        BigDecimal decimal0 = new BigDecimal(arg0);
        BigDecimal decimal1 = new BigDecimal(arg1);
        return decimal0.multiply(decimal1).toString();
    }

    public static String MultiplyNumbers(int arg0, String arg1) {
        BigDecimal decimal0 = new BigDecimal(arg0);
        BigDecimal decimal1 = new BigDecimal(arg1);
        return decimal0.multiply(decimal1).toString();
    }
    public static String loadJson(String path) throws IOException {
        InputStream inputStream = new FileInputStream(new File(path));
        Reader reader = new InputStreamReader(inputStream, "gbk");
        int ch = 0;
        StringBuffer sb = new StringBuffer();
        while ((ch = reader.read()) != -1) {
            sb.append((char) ch);
        }
        reader.close();
        return sb.toString();
    }

    public static List<ConfigInfo> jsonToObj(String str) {
        Gson gson = new Gson();
        Type type =new TypeToken<List<ConfigInfo>>() {}.getType();
        return gson.fromJson(str,type);
    }

    public static <T> String getEntityValue(T t, String str) {
        String value = null;
        if (CommonlyUtils.isEmpty(str)) return null;
        String name = str.substring(0, 1).toUpperCase() + str.substring(1);
        try {
            Method m = t.getClass().getMethod("get" + name);
            value = (String) m.invoke(t);
        } catch (NoSuchMethodException e) {
            e.printStackTrace();
        } catch (InvocationTargetException e) {
            e.printStackTrace();
        } catch (IllegalAccessException e) {
            e.printStackTrace();
        }
        return value;
    }

    public static void recordJson(Object obj,String str) {
        String json = JSONObject.toJSONString(obj);
        LogUtil.info(CommonlyUtils.class,str + json);
    }

    /**
     * 获取map中第一个数据值
     *
     * @param map 数据源
     * @return
     */
    public static Object getFirstOrNullByMap(Map<Object, Object> map) {
        Object obj = null;
        for (Map.Entry<Object, Object> entry : map.entrySet()) {
            obj = entry.getValue();
            if (obj != null) break;
        }
        return  obj;
    }

    /**数组排序
     *
     * @param list  排序数组
     * @param str   根据排序的字段名
     * @param <T>
     */
    public static <T> void sortList(List<T> list, String str) throws Exception {
        if (CommonlyUtils.isEmpty(str)) throw new Exception("字段名称为空！");
        Collections.sort(list, new Comparator<T>() {

            @Override
            public int compare(T t1, T t2) {
                try {
                    String v1 = CommonlyUtils.getEntityValue(t1,str);
                    String v2 = CommonlyUtils.getEntityValue(t2,str);
                    if (v1.compareTo(v2) >= 0) {
                        return 1;
                    } else {
                        return -1;
                    }
                } catch (NumberFormatException e2) {
                    return -1;
                }
            }
        });
    }

    //记录json数据
//    public static void recordJson(HttpServletRequest request) {
//        Gson gson = new Gson();
//        StringBuffer sbJson = new StringBuffer();
//        String type = request.getContentType();
//        Map<String,Object> receiveMap = new HashMap<String,Object>();
//        if("application/x-www-form-urlencoded".equals(type)){
//            Enumeration<String> enu = request.getParameterNames();
//            while (enu.hasMoreElements()) {
//                String key = String.valueOf(enu.nextElement());
//                String value = request.getParameter(key);
//                receiveMap.put(key, value);
//                sbJson.append("key>" + ",value>" + value);
//            }
//        }else{	//else是text/plain、application/json这两种情况
//            BufferedReader reader = null;
//            StringBuilder sb = new StringBuilder();
//            try{
//                reader = new BufferedReader(new InputStreamReader(request.getInputStream(), "utf-8"));
//                String line = null;
//                while ((line = reader.readLine()) != null){
//                    sb.append(line);
//                }
//            } catch (IOException e){
//                e.printStackTrace();
//            } finally {
//                try{
//                    if (null != reader){
//                        reader.close();
//                    }
//                } catch (IOException e){
//                    e.printStackTrace();
//                }
//            }
//            receiveMap = gson.fromJson(sb.toString(), new TypeToken<Map<String, String>>(){}.getType());//把JSON字符串转为对象
//        }
//        LogUtil.info(CommonlyUtils.class,sbJson.toString());
//    }
}
