package com.pjb.springbootjjwt.utils;

import cn.hutool.poi.excel.ExcelReader;
import cn.hutool.poi.excel.ExcelWriter;
import cn.hutool.poi.excel.StyleSet;
import org.apache.poi.hssf.usermodel.HSSFWorkbook;
import org.apache.poi.ss.usermodel.*;
import org.apache.poi.ss.util.AreaReference;
import org.apache.poi.ss.util.CellReference;

import java.io.Writer;

public class ExcelUtils {

    public static String getCellLocation(Workbook workbook, String cellName){
        Name name = workbook.getName(cellName);
        if (name == null) return "";
        String formula = name.getRefersToFormula();
//        LogUtil.info(ExcelUtils.class,"formula：" + formula);
//        if (CommonlyUtils.isEmpty(formula)) return "";
        String[] values = formula.split("!")[1].split("\\$");
        String loc = "";
        for (String value : values) {
            loc = loc + value;
        }
        return loc;
    }

    public static ExcelWriter getWriter(ExcelReader reader) throws Exception{
        if (reader == null) throw new Exception("文件不存在!");
        ExcelWriter writer = reader.getWriter();
        writer.disableDefaultStyle();
        return writer;
    }

    public static CellReference findCellByName(Workbook workbook, Sheet sheet, String name) {
        int namedCellIdx = workbook.getNameIndex(name);
        Name aNamedCell = workbook.getNameAt(namedCellIdx);
        AreaReference aref =null;
        try {
            aref=new AreaReference(aNamedCell.getRefersToFormula(),null);
        } catch (Exception e) {
            e.printStackTrace();
        }
        CellReference[] crefs = aref.getAllReferencedCells();
        if(crefs == null || crefs.length == 0) return null;
        return crefs[0];
    }

    /**
     * @param writer
     * @param x           单元格x轴坐标
     * @param y           单元格y轴坐标
     * @param pictureData 图片二进制数据
     * @param picType     图片格式
     */
    public static void writePic(ExcelWriter writer, int x, int y, byte[] pictureData, int picType) {
        Sheet sheet = writer.getSheet();
//        Drawing drawingPatriarch = sheet.createDrawingPatriarch();
//        //设置图片单元格位置
//        ClientAnchor anchor = drawingPatriarch.createAnchor(0, 0, 0, 0, x, y, x + 1, y + 1);
//        //随单元格改变位置和大小
//        anchor.setAnchorType(ClientAnchor.AnchorType.MOVE_AND_RESIZE);
//        //添加图片
//        int pictureIndex = sheet.getWorkbook().addPicture(pictureData, picType);
//        drawingPatriarch.createPicture(anchor, pictureIndex);

        Workbook workbook = writer.getWorkbook();
        int pictureIdx = workbook.addPicture(pictureData, picType);
        CreationHelper helper = workbook.getCreationHelper();
        Drawing drawing = sheet.createDrawingPatriarch();
        ClientAnchor anchor = helper.createClientAnchor();
        anchor.setCol1(x);
        anchor.setRow1(y);
        Picture pict = drawing.createPicture(anchor, pictureIdx);
        pict.resize(0.8);
    }

}
