package com.pjb.springbootjjwt.utils;

import com.alibaba.fastjson.JSON;
import com.pjb.springbootjjwt.entity.Result;
import com.pjb.springbootjjwt.entity.ResultOa;

import java.util.List;

public class ResultUtils {

    //返回错误信息
    public static Result errorResult(String msg){
        Result result = new Result();
        result.setCode("E");
        result.setMessage(msg);
        return result;
    }
    //返回错误信息OA
    public static ResultOa errorResultOa(String msg){
        ResultOa result = new ResultOa();
        result.setStatus("F");
        result.setMessage(msg);
        return result;
    }
    //返回代码错误信息
    public static Result errorResult(Throwable throwable){
        Result result = new Result();
        result.setCode("E");
        result.setMessage(throwable.getMessage());
        return result;
    }
    //返回代码错误信息OA
    public static ResultOa errorResultOa(Throwable throwable){
        ResultOa result = new ResultOa();
        result.setStatus("F");
        result.setMessage(throwable.toString());
        return result;
    }
    //返回成功信息
    public static Result successResult(String msg){
        Result result = new Result();
        result.setMessage(msg);
        return result;
    }
    //返回成功信息OA
    public static ResultOa successResultOa(String msg){
        ResultOa result = new ResultOa();
        result.setStatus("S");
        result.setMessage(msg);
        return result;
    }
    //返回成功信息
    public static Result successResult(Object obj){
        Result result = new Result();
        result.setCode("S");
        result.setMessage("请求成功");
        result.setData(JSON.toJSON(obj));
        return result;
    }
}
