package com.pjb.springbootjjwt.utils;

import cn.hutool.core.io.FileUtil;
import com.pjb.springbootjjwt.SpringbootJjwtApplication;
import com.pjb.springbootjjwt.constant.ConfigeType;
import com.pjb.springbootjjwt.entity.*;
import com.teamcenter.clientx.AppXSession;
import com.teamcenter.clientx.Query;
import com.teamcenter.schemas.soa._2006_03.exceptions.ServiceException;
import com.teamcenter.services.internal.strong.core.TypeService;
import com.teamcenter.services.loose.core._2006_03.FileManagement;
import com.teamcenter.services.strong.administration.PreferenceManagementService;
import com.teamcenter.services.strong.administration._2012_09.PreferenceManagement;
import com.teamcenter.services.strong.cad.StructureManagementService;
import com.teamcenter.services.strong.cad._2007_01.StructureManagement;
import com.teamcenter.services.strong.classification.ClassificationService;
import com.teamcenter.services.strong.classification._2007_01.Classification;
import com.teamcenter.services.strong.core.DataManagementService;
import com.teamcenter.services.strong.core.FileManagementService;
import com.teamcenter.services.strong.core.ProjectLevelSecurityService;
import com.teamcenter.services.strong.core.SessionService;
import com.teamcenter.services.strong.core._2007_01.DataManagement;
import com.teamcenter.services.strong.core._2007_12.Session;
import com.teamcenter.services.strong.query.SavedQueryService;
import com.teamcenter.services.strong.query._2006_03.SavedQuery;
import com.teamcenter.services.strong.workflow.WorkflowService;
import com.teamcenter.services.strong.workflow._2008_06.Workflow;
import com.teamcenter.soa.client.FileManagementUtility;
import com.teamcenter.soa.client.GetFileResponse;
import com.teamcenter.soa.client.model.ErrorStack;
import com.teamcenter.soa.client.model.Lov;
import com.teamcenter.soa.client.model.ModelObject;
import com.teamcenter.soa.client.model.Property;
import com.teamcenter.soa.client.model.ServiceData;
import com.teamcenter.soa.client.model.strong.*;
import com.teamcenter.soa.client.model.strong.User;
import com.teamcenter.soa.exceptions.NotLoadedException;

import javax.servlet.http.HttpServletResponse;
import java.io.*;
import java.math.BigInteger;
import java.net.URLEncoder;
import java.nio.file.Files;
import java.nio.file.Paths;
import java.util.*;

public class TCUtils {

    public static AppXSession session;
    public static User curuser;

    public static void login() {
        if (session == null) session = new AppXSession(SpringbootJjwtApplication.TC_URL);
        if (curuser == null) curuser =  session.login(SpringbootJjwtApplication.TC_USER,
                SpringbootJjwtApplication.TC_PWD, "KH_Session1");
    }

    public static AppXSession getSession() { return session; }

    public static User getCuruser() { return curuser; }

    //登录TC
    public static User login(AppXSession session, String sessionDiscriminator) {
        return session.login(SpringbootJjwtApplication.TC_USER, SpringbootJjwtApplication.TC_PWD, sessionDiscriminator);
    }

    //登出TC
    public static void logoutUser(AppXSession session) {
        //if (session != null) session.logout();
    }

    // 设置ModelObject属性
    public static void setModelObjectValue(AppXSession session, ModelObject[] modelObjects, String[] props) {
        DataManagementService dMService = DataManagementService.getService(session.getConnection());
        if (!CommonlyUtils.isEmpty(modelObjects)) {
            dMService.refreshObjects(modelObjects);
            dMService.getProperties(modelObjects, props);
        }
    }

    public static void setModelObjectValue(AppXSession session, ModelObject[] modelObjects, String props) {
        setModelObjectValue(session, modelObjects, new String[]{props});
    }

    // 设置ModelObject属性
    public static void setModelObjectValue(AppXSession session, ModelObject modelObjects, String[] props) {
        setModelObjectValue(session, new ModelObject[]{modelObjects}, props);
    }

    // 设置ModelObject属性
    public static void setModelObjectValue(AppXSession session, ModelObject modelObjects, String props) {
        setModelObjectValue(session, new ModelObject[]{modelObjects}, new String[]{props});
    }

    //取消加载属性
    public static void unloadlValue(AppXSession session, ModelObject[] objects) {
        DataManagementService dMService = DataManagementService.getService(session.getConnection());
        dMService.unloadObjects(objects);
    }

    //取消加载属性
    public static void unloadlValue(AppXSession session, ModelObject object) {
        unloadlValue(session, new ModelObject[]{object});
    }

    //删除对象
    public static void delete(AppXSession session, ModelObject[] objects) throws Exception {
        DataManagementService dMService = DataManagementService.getService(session.getConnection());
        ServiceData serviceData = dMService.deleteObjects(objects);
//        checkPartialErrors(serviceData);
    }

    public static void delete(AppXSession session, ModelObject object) throws Exception {
        delete(session, new ModelObject[]{object});
    }

    //加载BOM结构中版本的属性
    public static Map<ModelObject, ModelObject> setBOMRevValue(AppXSession session, ModelObject[] modelObjects,
                                                               String[] props) throws NotLoadedException {
        Map<ModelObject, ModelObject> map = new HashMap<>();
        if (!CommonlyUtils.isEmpty(modelObjects)) {
            TCUtils.setModelObjectValue(session, modelObjects, "bl_line_object");
            List<ModelObject> mlist = new ArrayList<>();
            for (ModelObject child : modelObjects) {
                BOMLine line = (BOMLine) child;
                ModelObject rev = line.get_bl_line_object();
                mlist.add(rev);
                map.put(line, rev);
            }
            TCUtils.setModelObjectValue(session, mlist.toArray(new ModelObject[mlist.size()]), props);
        }
        return map;
    }

    //根据首选项名称获取首选项值
    public static String[] getPreferenceValue(AppXSession session, String preferenceName) throws Exception {
        PreferenceManagementService pmService = PreferenceManagementService.getService(session.getConnection());
        PreferenceManagement.GetPreferencesResponse getPreferencesResponse
                = pmService.getPreferences(new String[]{preferenceName}, false);
        checkPartialErrors(getPreferencesResponse.data);
        PreferenceManagement.CompletePreference[] completePreferences = getPreferencesResponse.response;
        PreferenceManagement.PreferenceValue preferenceValue = completePreferences[0].values;
        return preferenceValue.values;
    }

    public static ModelObject getItemByUID(AppXSession session, String uid) throws Exception {
        List<ModelObject> items = getItemByUID(session, new String[]{uid});
        return CommonlyUtils.isEmptyList(items) ? null : items.get(0);
    }

    //根据PUID找对象
    public static List<ModelObject> getItemByUID(AppXSession session, String[] uids) throws Exception {
        List<ModelObject> list = new ArrayList<>();
        DataManagementService dMService = DataManagementService.getService(session.getConnection());
        ServiceData serviceData = dMService.loadObjects(uids);
        checkPartialErrors(serviceData);
        if (serviceData.sizeOfPlainObjects() > 0) {
            for (int i = 0, len = serviceData.sizeOfPlainObjects(); i < len; i++) {
                ModelObject modelObject = serviceData.getPlainObject(i);
                list.add(modelObject);
            }
        }
        return list;
    }

    //开旁路
    public static void setByPass(AppXSession session, boolean b) throws Exception {
        SessionService sessionService = SessionService.getService(session.getConnection());
        Session.StateNameValue[] propPairs = new Session.StateNameValue[1];
        propPairs[0] = new Session.StateNameValue();
        propPairs[0].name = "bypassFlag";
        propPairs[0].value = com.teamcenter.soa.client.model.Property.toBooleanString(b);
        ServiceData data = sessionService.getService(AppXSession.getConnection()).setUserSessionState(propPairs);
        if (displayErrors(data).length() > 0) {
            throw new Exception(b ? "开启旁路失败！" : "关闭旁路失败！");
        }
    }

    // 根据对象获取他的最后一个版本
    public static ItemRevision getRevision(AppXSession session, ModelObject obj) throws NotLoadedException {
        if (obj instanceof Item) {
            Item item = (Item) obj;
            setModelObjectValue(session, item, "revision_list");
            ModelObject[] modelObjects = item.get_revision_list();
            DataManagementService dataManagementService;
            if (!CommonlyUtils.isEmpty(modelObjects)) return (ItemRevision) modelObjects[modelObjects.length - 1];
        }
        return null;
    }

    //获取所有版本
    public static ModelObject[] getRevisions(AppXSession session, ModelObject obj) throws NotLoadedException {
        if (obj instanceof Item) {
            Item item = (Item) obj;
            setModelObjectValue(session, item, "revision_list");
            ModelObject[] modelObjects = item.get_revision_list();
            if (!CommonlyUtils.isEmpty(modelObjects)) return modelObjects;
        }
        return null;
    }

    // 根据对象获取最新发布版本（过滤发布状态）
    public static ItemRevision getRevisionReleased_Filter(AppXSession session, ModelObject obj, String[] preferences) throws NotLoadedException {
        ModelObject[] itemRevisions = getRevisions(session, obj);
        setModelObjectValue(session, itemRevisions, "release_status_list");
        if (!CommonlyUtils.isEmpty(itemRevisions)) {
            ArrayList< String> preferenceList = new ArrayList<String>(preferences.length);
            Collections.addAll(preferenceList, preferences);
            for (int i = itemRevisions.length; i > 0; i--) {
                ItemRevision rev = (ItemRevision) itemRevisions[i-1];
                ModelObject[] status = rev.get_release_status_list();
                setModelObjectValue(session, status, "object_name");
                if(status.length != 0){
                    String name = status[status.length-1].getPropertyDisplayableValue("object_name");
                    if (preferenceList.contains(name)) continue;
                    System.out.println();
                    return rev;
                }

            }
        }
        return null;
    }
    // 根据对象获取指定版本
    public static ItemRevision getRevisionReleasedByRevID(AppXSession session, ModelObject obj,String rev_id) throws NotLoadedException {
        ModelObject[] itemRevisions = getRevisions(session, obj);
        if (!CommonlyUtils.isEmpty(itemRevisions)) {

            for (int i = itemRevisions.length; i > 0; i--) {
                ItemRevision rev = (ItemRevision) itemRevisions[i-1];
                TCUtils.setModelObjectValue(session, new ModelObject[]{rev}, new String[]{"item_revision_id"});
                String item_revision_id = rev.get_item_revision_id();
                if(item_revision_id.equals(rev_id)){
                    return rev;
                }
            }
        }
        return null;
    }
    // 根据对象获取最新发布版本
    public static ItemRevision getRevisionReleased(AppXSession session, ModelObject obj) throws NotLoadedException {
        ModelObject[] itemRevisions = getRevisions(session, obj);
        setModelObjectValue(session, itemRevisions, "release_status_list");
        if (!CommonlyUtils.isEmpty(itemRevisions)) {
            for (int i = itemRevisions.length; i > 0; i--) {
                ItemRevision rev = (ItemRevision) itemRevisions[i-1];
                ModelObject[] status = rev.get_release_status_list();
                if (!CommonlyUtils.isEmpty(status)) return rev;
            }
        }
        return null;
    }
    /**获取表单上lov的中文本地化值
     *
     * @param session
     * @param modelObject
     * @param prop
     * @return
     * @throws NotLoadedException
     */
    public static String getLovValueAsCN(AppXSession session, ModelObject modelObject, String prop)
            throws Exception {
        DataManagementService dMService = DataManagementService.getService(session.getConnection());
        setModelObjectValue(session,modelObject,prop);
        Property property = modelObject.getPropertyObject(prop);
        Lov Lov = property.getPropertyDescription().getLovReference();
        if(Lov != null) {
            com.teamcenter.services.strong.core._2010_04.DataManagement.PropertyInfo localizedInfo =
                    new com.teamcenter.services.strong.core._2010_04.DataManagement.PropertyInfo() ;
            localizedInfo.object = modelObject;
            com.teamcenter.services.strong.core._2010_04.DataManagement.NameLocaleStruct localeStruct =
                    new com.teamcenter.services.strong.core._2010_04.DataManagement.NameLocaleStruct();
            localeStruct.locales = new String[] {"zh_CN"};
            localeStruct.name  =prop;
            localizedInfo.propsToget =
                    new com.teamcenter.services.strong.core._2010_04.DataManagement.NameLocaleStruct[] {localeStruct};
            com.teamcenter.services.strong.core._2015_07.DataManagement.LocalizedPropertyValuesResponse valueResponse =
                    dMService.getLocalizedProperties2(
                            new com.teamcenter.services.strong.core._2010_04.DataManagement.PropertyInfo[] { localizedInfo});
            String lovValue = valueResponse.output[0].propertyValues[0].values[0];//本地化值
            return lovValue;
        }
        throw new Exception("传入的对象中不存在" + prop + "的LOV属性");
    }

    //根据分类库ID获取分类库属性（暂时没用）
    public static String getClassAttrForId(AppXSession session, String classId) throws Exception {
        String name = null;
        ClassificationService classService = ClassificationService.getService(session.getConnection());
        Classification.GetAttributesForClassesResponse response = classService.getAttributesForClasses(new String[]{classId});
        checkPartialErrors(response.data);
        Map<String, Classification.ClassAttribute[]> attrMap = response.attributes;
        for (Map.Entry<String, Classification.ClassAttribute[]> map : attrMap.entrySet()) {
            String key = map.getKey();
            Classification.ClassAttribute[] attributes = map.getValue();
            System.out.println("attributes长度= " + attributes.length);
            System.out.println("key= " + key);
            System.out.println("id= " + attributes[0].id);
            System.out.println("name= " + attributes[0].name);
            name = attributes[0].name;
        }
        return name;
    }


    // 影响分析向上获取对象
    public static List<ModelObject> whereReference(AppXSession session, WorkspaceObject[] obj, int number) throws Exception {
        List<ModelObject> list = new ArrayList<>();
        DataManagementService dMService = DataManagementService.getService(session.getConnection());
        DataManagement.WhereReferencedResponse response = dMService.whereReferenced(obj, number);
        checkPartialErrors(response.serviceData);
        DataManagement.WhereReferencedInfo[] info = response.output[0].info;
        if (CommonlyUtils.isEmptyArray(info)) return null;
        for (int i = 0; i < info.length; i++) {
            list.add(info[i].referencer);
        }
        return list;
    }

    // 影响分析向上获取某些类型对象
    public static List<ModelObject> whereReference(AppXSession session, WorkspaceObject[] obj, int number,
                                                   List<String> typeList) throws Exception {
        List<ModelObject> list = new ArrayList<>();
        List<ModelObject> objlist = new ArrayList<>();
        DataManagementService dMService = DataManagementService.getService(session.getConnection());
        DataManagement.WhereReferencedResponse response = dMService.whereReferenced(obj, number);
        checkPartialErrors(response.serviceData);
        DataManagement.WhereReferencedInfo[] info = response.output[0].info;
        if (CommonlyUtils.isEmptyArray(info)) return null;
        for (DataManagement.WhereReferencedInfo i : info) {
            objlist.add(i.referencer);
        }
        setModelObjectValue(session, objlist.toArray(new ModelObject[objlist.size()]), "object_type");
        for (int i = 0; i < info.length; i++) {
            WorkspaceObject model = info[i].referencer;
            if (typeList.contains(model.get_object_type())) list.add(model);
        }
        return list;
    }

    /**
     * 影响分析向上获取被某种关系关联的对象
     *
     * @param obj        需要查询的对象
     * @param reference  引用关系
     * @param objectType 父引用对象类型
     * @param number     层级
     * @return 查询到所有相关的父引用对象
     */
    public static List<ModelObject> getWhereReference(AppXSession session, ModelObject obj, String reference, String objectType,
                                                      int number) throws Exception {
        DataManagementService dMService = DataManagementService.getService(session.getConnection());
        List<ModelObject> list = new ArrayList<>();
        com.teamcenter.services.strong.core._2007_06.DataManagement.WhereReferencedByRelationNameInfo[] var1
                = new com.teamcenter.services.strong.core._2007_06.DataManagement.WhereReferencedByRelationNameInfo[1];
        com.teamcenter.services.strong.core._2007_06.DataManagement.RelationAndTypesFilter[] filter
                = new com.teamcenter.services.strong.core._2007_06.DataManagement.RelationAndTypesFilter[1];
        var1[0] = new com.teamcenter.services.strong.core._2007_06.DataManagement.WhereReferencedByRelationNameInfo();
        filter[0] = new com.teamcenter.services.strong.core._2007_06.DataManagement.RelationAndTypesFilter();
        filter[0].relationTypeName = reference;
        filter[0].otherSideObjectTypes = new String[]{objectType};
        var1[0].object = obj;
        var1[0].filter = filter;
        com.teamcenter.services.strong.core._2007_06.DataManagement.WhereReferencedByRelationNameResponse response
                = dMService.whereReferencedByRelationName(var1, number);
        checkPartialErrors(response.serviceData);
        if (!CommonlyUtils.isEmptyArray(response.output)) {
            com.teamcenter.services.strong.core._2007_06.DataManagement.WhereReferencedByRelationNameOutputInfo[] info
                    = response.output[0].info;
            for (int i = 0; i < info.length; i++) {
                list.add(info[i].referencer);
            }
        }
        return list;
    }

    public static void closeBOMWindow(AppXSession session, ItemRevision parentObject) throws Exception {
        StructureManagementService smService = StructureManagementService.getService(session.getConnection());
        StructureManagement.CreateBOMWindowsInfo[] createBOMWindowsInfo = new StructureManagement.CreateBOMWindowsInfo[1];
        createBOMWindowsInfo[0] = new StructureManagement.CreateBOMWindowsInfo();
        createBOMWindowsInfo[0].itemRev = parentObject;
        StructureManagement.CreateBOMWindowsResponse createBOMWindowsResponse
                = smService.createBOMWindows(createBOMWindowsInfo);
        checkPartialErrors(createBOMWindowsResponse.serviceData);
        if (CommonlyUtils.isEmptyArray(createBOMWindowsResponse.output)) return;
        closeBOMWindow(smService, createBOMWindowsResponse.output[0].bomWindow);
    }

    public static void saveBOMWindow(StructureManagementService smService, BOMWindow bomWindow) throws Exception {
        com.teamcenter.services.strong.cad._2008_06.StructureManagement.SaveBOMWindowsResponse saveResponse =
                smService.saveBOMWindows(new BOMWindow[]{bomWindow});
        checkPartialErrors(saveResponse.serviceData);
    }

    public static void closeBOMWindow(StructureManagementService smService, BOMWindow bomWindow) throws Exception {
        StructureManagement.CloseBOMWindowsResponse response = null;
        if (smService != null && bomWindow != null)
            response = smService.closeBOMWindows(new BOMWindow[] { bomWindow });
        checkPartialErrors(response.serviceData);
    }

    /**获取工艺规范管理器中工序对象的BOMLine
     *
     * @param session
     * @param obj
     * @return
     * @throws Exception
     */
    public  static BOMLine getMfg0BomLineOfModelObject(AppXSession session, ModelObject obj) throws Exception {
        com.teamcenter.services.strong.manufacturing.DataManagementService dMService =
                com.teamcenter.services.strong.manufacturing.DataManagementService.getService(session.getConnection());
        com.teamcenter.services.strong.manufacturing._2011_06.DataManagement.OpenContextInput input =
                new com.teamcenter.services.strong.manufacturing._2011_06.DataManagement.OpenContextInput();
        input.object = obj;
        com.teamcenter.services.strong.manufacturing._2011_06.DataManagement.OpenContextsResponse response =
                dMService.openContexts(
                        new com.teamcenter.services.strong.manufacturing._2011_06.DataManagement.OpenContextInput[]{input});
        checkPartialErrors(response.serviceData);
        if (CommonlyUtils.isEmptyArray(response.output)) return null;
        return (BOMLine) response.output[0].contexts[0].context;
    }
    //获取对象中BOM的子对象
    public static ModelObject[] getBomLine(AppXSession session,ItemRevision itemRevision) throws Exception{
        StructureManagementService smService = StructureManagementService.getService( session.getConnection());
        StructureManagement.CreateBOMWindowsInfo[] createBOMWindowsInfo = new StructureManagement.CreateBOMWindowsInfo[1];
        createBOMWindowsInfo[0] = new StructureManagement.CreateBOMWindowsInfo();
        createBOMWindowsInfo[0].itemRev = itemRevision;
        StructureManagement.CreateBOMWindowsResponse createBOMWindowsResponse = smService.createBOMWindows(createBOMWindowsInfo);
        if(createBOMWindowsResponse.output != null && createBOMWindowsResponse.output.length != 0){
            BOMLine topBomLine = (BOMLine) createBOMWindowsResponse.output[0].bomLine;
            setModelObjectValue(session,new BOMLine[]{topBomLine},new String[]{"bl_child_lines"});
            ModelObject[] childrenBomLines =  topBomLine.get_bl_child_lines();
            if (childrenBomLines != null && childrenBomLines.length > 0) {
                return childrenBomLines;
            }
        }

        return null;
    }
    //获取对象中BOM的子对象(在非精确BOM中使用会存在BOM子对象未发布的情况)
    public static ModelObject[] getBomLineByWork(AppXSession session, ItemRevision itemRevision) //BOMWindow window
            throws Exception {
        StructureManagementService smService = StructureManagementService.getService(session.getConnection());
        StructureManagement.CreateBOMWindowsInfo[] createBOMWindowsInfo = new StructureManagement.CreateBOMWindowsInfo[1];
        createBOMWindowsInfo[0] = new StructureManagement.CreateBOMWindowsInfo();
        createBOMWindowsInfo[0].itemRev = itemRevision;
        StructureManagement.CreateBOMWindowsResponse createBOMWindowsResponse
                = smService.createBOMWindows(createBOMWindowsInfo);
        checkPartialErrors(createBOMWindowsResponse.serviceData);
        if (CommonlyUtils.isEmptyArray(createBOMWindowsResponse.output)) return null;
//        window = createBOMWindowsResponse.output[0].bomWindow;
        BOMLine topBomLine = createBOMWindowsResponse.output[0].bomLine;
        setModelObjectValue(session, topBomLine, "bl_child_lines");
        ModelObject[] childrenBomLines = topBomLine.get_bl_child_lines();
        if (!CommonlyUtils.isEmpty(childrenBomLines)) return childrenBomLines;
        return null;
    }

    //获取根据版本规则加载BOM对象中的子对象，(目前使用的是TC12版本之后的)
    public static ModelObject[] getBomLineByRevRule(AppXSession session, ItemRevision itemRevision, String revRule)
            throws Exception {
        StructureManagementService smService = StructureManagementService.getService(session.getConnection());
        com.teamcenter.services.strong.cad._2019_06.StructureManagement.CreateWindowsInfo3 createWindowsInfo3s
                = new com.teamcenter.services.strong.cad._2019_06.StructureManagement.CreateWindowsInfo3();
        StructureManagement.RevisionRuleConfigInfo revisionRuleConfigInfo = new StructureManagement.RevisionRuleConfigInfo();
        RevisionRule revisionRule = getRevisionRule(session, revRule);
        revisionRuleConfigInfo.revRule = revisionRule;
        createWindowsInfo3s.itemRev = itemRevision;
        createWindowsInfo3s.revRuleConfigInfo = revisionRuleConfigInfo;
        StructureManagement.CreateBOMWindowsResponse createBOMWindowsResponse = smService.createOrReConfigureBOMWindows(
                new com.teamcenter.services.strong.cad._2019_06.StructureManagement.CreateWindowsInfo3[]{createWindowsInfo3s});
        checkPartialErrors(createBOMWindowsResponse.serviceData);
        BOMLine topBomLine = createBOMWindowsResponse.output[0].bomLine;
        if (CommonlyUtils.isEmptyArray(createBOMWindowsResponse.output)) return null;
        setModelObjectValue(session, topBomLine, "bl_child_lines");
        ModelObject[] childrenBomLines = topBomLine.get_bl_child_lines();
        if (!CommonlyUtils.isEmpty(childrenBomLines)) return childrenBomLines;
        return null;
    }

    public static ModelObject[] getBomLineByReleasedAndWork(AppXSession session, ItemRevision itemRevision) throws Exception {
        return getBomLineByRevRule(session, itemRevision, "Any Status; Working");
    }

    //获取版本规则
    public static RevisionRule getRevisionRule(AppXSession session, String name)
            throws Exception {
        StructureManagementService smService = StructureManagementService.getService(session.getConnection());
        RevisionRule revRule = null;
        StructureManagement.GetRevisionRulesResponse rulesResponse = smService.getRevisionRules();
        checkPartialErrors(rulesResponse.serviceData);
        StructureManagement.RevisionRuleInfo[] ruleInfos = rulesResponse.output;
        for (StructureManagement.RevisionRuleInfo ruleInfo : ruleInfos) {
            revRule = ruleInfo.revRule;
            setModelObjectValue(session, revRule, "object_name");
            String rulename = revRule.get_object_name();
            if (name.equals(rulename)) return revRule;
        }
        return revRule;
    }

    //关闭BOM窗口
    public static void closeBOM(AppXSession session, BOMWindow bomWindow) {
        StructureManagementService smService = StructureManagementService.getService(session.getConnection());
        smService.closeBOMWindows(new BOMWindow[]{bomWindow});
    }

    //关闭BOM窗口
    public static void closeBOM(AppXSession session, ModelObject modelObject) throws NotLoadedException {
        if (modelObject instanceof BOMLine){
            BOMLine line = (BOMLine)modelObject;
            TCUtils.setModelObjectValue(session,line,"bl_window");
            closeBOM(session,(BOMWindow)line.get_bl_window());
        }
    }

    public static Map<String, String> getClassNameAndId(AppXSession session, ItemRevision rev) throws Exception {
        ClassificationService classificationService = ClassificationService.getService(session.getConnection());
        setModelObjectValue(session, rev, "IMAN_classification");
        ModelObject[] obj = rev.get_IMAN_classification();
        if (!CommonlyUtils.isEmpty(obj)) {
            Classification.GetClassificationObjectsResponse response = classificationService.getClassificationObjects(obj);
            checkPartialErrors(response.data);
            String id = response.clsObjs.get(obj[0]).classId;
            Classification.ClassDef classDef = getClassDesc(session, id);
            if (classDef == null) return null;
            String name = classDef.name;
            Map<String, String> map = new HashMap<>();
            map.put(id, name);
            return map;
        } else return null;
    }

    //获取分类库的属性
    public static Map<String, Classification.ClassDef> getClassDesc(AppXSession session, String[] classIds) throws Exception {
        ClassificationService classificationService = ClassificationService.getService(session.getConnection());
        Classification.GetClassDescriptionsResponse response = classificationService.getClassDescriptions(classIds);
        checkPartialErrors(response.data);
        return response.descriptions;
    }

    public static Classification.ClassDef getClassDesc(AppXSession session, String classId) throws Exception {
        Map<String, Classification.ClassDef> map = getClassDesc(session, new String[]{classId});
        if (map != null && map.size() > 0) return map.get(classId);
        return null;
    }

    //获取分类库的子库
    public static Map<String, Classification.ChildDef[]> getChildrenClass(AppXSession session, String classId) throws Exception {
        ClassificationService classificationService = ClassificationService.getService(session.getConnection());
        Classification.GetChildrenResponse response = classificationService.getChildren(new String[]{classId});
        checkPartialErrors(response.data);
        return response.children;
    }

    //获取版本在分类中的分类属性
    public static Classification.ClassAttribute[] getClassAttribute(AppXSession session, ItemRevision rev) throws Exception {
        ClassificationService classificationService = ClassificationService.getService(session.getConnection());
        setModelObjectValue(session, rev, "IMAN_classification");
        ModelObject[] obj = rev.get_IMAN_classification();
        if (!CommonlyUtils.isEmpty(obj)) {
            Classification.GetClassificationObjectsResponse response = classificationService.getClassificationObjects(obj);
            checkPartialErrors(response.data);
            String classId = response.clsObjs.get(obj[0]).classId;
            Classification.GetAttributesForClassesResponse response1
                    = classificationService.getAttributesForClasses(new String[]{classId});
            checkPartialErrors(response1.data);
            Map<String, Classification.ClassAttribute[]> attributesMap = response1.attributes;
            if (attributesMap == null && attributesMap.size() < 1) return null;
//            return attributesMap.get(classId);
            for (Map.Entry<String, Classification.ClassAttribute[]> m : attributesMap.entrySet()) {
                return m.getValue();
            }
        }
        return null;
    }

    //获取对象在分类中某些分类属性的值
    public static List<ClassProperties> getClassProperty(AppXSession session, ItemRevision rev, List<Integer> classpropids)
            throws Exception {
        ClassificationService classificationService = ClassificationService.getService(session.getConnection());
        List<ClassProperties> classPropList = new ArrayList<>();
        setModelObjectValue(session, rev, "IMAN_classification");
        ModelObject[] obj = rev.get_IMAN_classification();
        if (!CommonlyUtils.isEmpty(obj)) {
            Classification.GetClassificationObjectsResponse response = classificationService.getClassificationObjects(obj);
            checkPartialErrors(response.data);
            Classification.ClassificationProperty[] properties = response.clsObjs.get(obj[0]).properties;
            for (Classification.ClassificationProperty property : properties) {
                ClassProperties classProperties = new ClassProperties();
                int id = property.attributeId;
                if (classpropids.contains(id)) {
                    classProperties.setID(property.attributeId);
                    classProperties.setValue(property.values[0].dbValue != null ? property.values[0].dbValue : "");
                    classPropList.add(classProperties);
                }
            }
        }
        return classPropList;
    }

    public static ClassProperties getClassProperty(AppXSession session, ItemRevision rev, int classpropid)
            throws Exception {
        List<Integer> list = new ArrayList<>();
        list.add(classpropid);
        List<ClassProperties> classProplist = getClassProperty(session, rev, list);
        return classProplist.size() > 0 ? classProplist.get(0) : null;
    }

    //根据puid获取对象
    public static ModelObject getItemByPuid(AppXSession session, String puid) throws Exception {
        DataManagementService dMService = DataManagementService.getService(session.getConnection());
        if (!CommonlyUtils.isEmpty(puid)) {
            ServiceData data = dMService.loadObjects(new String[]{puid});
            checkPartialErrors(data);
            if (data.sizeOfPlainObjects() > 0) return data.getPlainObject(0);
        }
        return null;
    }

    //获取对象版本下某个关系数据集的地址
    public static List<String> getFileByFMS(AppXSession session, ModelObject modelObject, String ref, String drawingItemID, String drawingItemRevID) throws Exception {
        List<String> list = null;
        if (!CommonlyUtils.isEmpty(modelObject)) {
            list = new ArrayList<>();
            Map<String, File> fileMap = downFileByFMS(session, modelObject, ref ,drawingItemID + File.separator + drawingItemRevID);
            if(fileMap != null && fileMap.size() != 0){
                for (Map.Entry<String, File> map : fileMap.entrySet()) {
                    String name = map.getKey();
                    File file = map.getValue();
                    changeFileName(file, name);
                    String url = SpringbootJjwtApplication.ADDRESS + "/"+ drawingItemID + "/" +drawingItemRevID + "/" +name;
                    list.add(url);
                }
            }

        }
        return list;
    }
    //移除关系
    public static void removeRelation(ModelObject primary , ModelObject secodary , String relationType) throws Exception {
        DataManagementService dMService = DataManagementService.getService(session.getConnection());
        com.teamcenter.services.strong.core._2006_03.DataManagement.Relationship[] relationships = new com.teamcenter.services.strong.core._2006_03.DataManagement.Relationship[1];
        com.teamcenter.services.strong.core._2006_03.DataManagement.Relationship relationship = new com.teamcenter.services.strong.core._2006_03.DataManagement.Relationship();
        relationship.primaryObject = primary;
        relationship.secondaryObject =  secodary;
        relationship.relationType = relationType;
        relationships[0] = relationship;
        ServiceData serviceData = dMService.deleteRelations(relationships);
        checkPartialErrors(serviceData);
    }
    //获取对象版本下某个关系下文件夹下数据集的地址
    public static List<String> getFolderFileByFMS(AppXSession session, ModelObject modelObject, String ref) throws Exception {
        List<String> list = new ArrayList<String>();
        if (!CommonlyUtils.isEmpty(modelObject)) {
            list = downFolderFileByFMS(session, modelObject, ref);
        }
        return list;
    }
    // 获取某个关系下的所有文件
    public static Map<String, File> downFileByFMS(AppXSession session, ModelObject itemRev, String str, String perfix) throws Exception {
        Map<String, File> fileMap = new HashMap<>();
        if (!CommonlyUtils.isEmpty(itemRev)) {
            setModelObjectValue(session, itemRev, str);
            ModelObject[] dataset = itemRev.getPropertyObject(str).getModelObjectArrayValue();
            if (CommonlyUtils.isEmpty(dataset)) return null;
            setModelObjectValue(session, dataset, "ref_list");
            for (ModelObject dataSet : dataset) {
                if (dataSet instanceof Dataset) {
                    Dataset dt = (Dataset) dataSet;
                    setModelObjectValue(session, dt, "dataset_type");
                    DatasetType dataset_type = dt.get_dataset_type();
                    setModelObjectValue(session, dataset_type, "datasettype_name");
                    String datasettype_name = dataset_type.get_datasettype_name();
                    if(datasettype_name.equals("PDF")){
                        Map<String, File> tcFile = TCFileToFile(session, dt ,perfix);
                        fileMap.putAll(tcFile);
                    }

                }
            }
        }
        return fileMap;
    }
    // 获取某个关系下文件夹下的所有文件
    public static List<String> downFolderFileByFMS(AppXSession session, ModelObject itemRev, String str) throws Exception {
        List<String> list = new ArrayList<String>();
//        Map<String, File> fileMap = new HashMap<>();
        if (!CommonlyUtils.isEmpty(itemRev)) {
            setModelObjectValue(session, itemRev, str);
            ModelObject[] folders = itemRev.getPropertyObject(str).getModelObjectArrayValue();
            if (CommonlyUtils.isEmpty(folders)) return list;
            for(ModelObject folder : folders){
                if(folder instanceof  Folder){
                    setModelObjectValue(session, folder, "contents");
                    String folderName = ((Folder) folder).get_object_name();
                    ModelObject[] contents = ((Folder) folder).get_contents();
                    setModelObjectValue(session, contents, "ref_list");
                    for (ModelObject dataSet : contents) {
                        if (dataSet instanceof Dataset) {
                            Dataset dt = (Dataset) dataSet;
                            setModelObjectValue(session, dt, "dataset_type");
                            DatasetType dataset_type = dt.get_dataset_type();
                            setModelObjectValue(session, dataset_type, "datasettype_name");
                            String datasettype_name = dataset_type.get_datasettype_name();
                            if(datasettype_name.equals("PDF")){
                                Map<String, File> tcFile = TCFileToFile(session, dt ,folderName);
                                for (Map.Entry<String, File> map : tcFile.entrySet()) {
                                    String name = map.getKey();
                                    File file = map.getValue();
                                    changeFileName(file, name);
                                    String url = SpringbootJjwtApplication.ADDRESS + "/"+ folderName + "/" +name;
                                    list.add(url);
                                }
                            }
                        }

                    }

                }

            }

        }
        return list;
    }
    //TCFMS中的文件转换到本地
    private static Map<String, File> TCFileToFile(AppXSession session, Dataset dataset, String perfix) throws Exception {
        if (CommonlyUtils.isEmpty(dataset)) return null;
        Map<String, File> fileMap = new HashMap<>();
        File outFile = null;
        String filename = "";
        String fcccachPath = SpringbootJjwtApplication.TC_FCCCACH + File.separator + perfix;
        File directory = new File(fcccachPath);
        if (!directory.exists()){
            directory.mkdirs();
        }
        FileManagementUtility fmu = new FileManagementUtility(AppXSession.getConnection(),
                null,
                new String[]{SpringbootJjwtApplication.TC_FMSURL},
                new String[]{SpringbootJjwtApplication.TC_FMSURL},
                fcccachPath);
        ModelObject[] objects = dataset.get_ref_list();
        setModelObjectValue(session, objects[0], "original_file_name");
        filename = objects[0].getPropertyObject("original_file_name").getStringValue();
//        filename = CommonlyUtils.getNowDate() + filename;
        GetFileResponse getFileResponse = fmu.getFiles(objects);
        File[] fileinfovec = getFileResponse.getFiles();
        fmu.term();
        outFile = fileinfovec[0];
        filename = checkFileName(filename);
        fileMap.put(filename, outFile);
        return fileMap;
    }

    //数据集转换为File
    public static File loadFileFromTc(AppXSession session, Dataset dataset) throws Exception {
        if (CommonlyUtils.isEmpty(dataset)) return null;
        FileManagementUtility fmu = new FileManagementUtility(AppXSession.getConnection(),
                null,
                new String[]{SpringbootJjwtApplication.TC_FMSURL},
                new String[]{SpringbootJjwtApplication.TC_FMSURL},
                SpringbootJjwtApplication.TC_FCCCACH);
        setModelObjectValue(session, dataset, "ref_list");
        ModelObject[] objects = dataset.get_ref_list();
        TCUtils.setModelObjectValue(session, objects[0], "original_file_name");
        String filename = objects[0].getPropertyObject("original_file_name").getStringValue();
        GetFileResponse getFileResponse = fmu.getFiles(objects);
        File[] fileinfovec = getFileResponse.getFiles();
        fmu.term();
        if (CommonlyUtils.isEmptyArray(fileinfovec)) throw new FileNotFoundException("数据集命名引用不存在!!!");
        String now = CommonlyUtils.getNowDate();
//        String path = changeFileName(fileinfovec[0],now + filename);
        File newFile = changeFileName2(fileinfovec[0],now + UUID.randomUUID() + filename);
        return newFile;
    }

    //数据集转换为File
    public static File loadFileFromTc2(AppXSession session, Dataset dataset) throws Exception {
        if (CommonlyUtils.isEmpty(dataset)) return null;
        FileManagementUtility fmu = new FileManagementUtility(AppXSession.getConnection(),
                null,
                new String[]{SpringbootJjwtApplication.TC_FMSURL},
                new String[]{SpringbootJjwtApplication.TC_FMSURL},
                SpringbootJjwtApplication.TC_FCCCACH);
        setModelObjectValue(session, dataset, "ref_list");
        ModelObject[] objects = dataset.get_ref_list();
        TCUtils.setModelObjectValue(session, objects[0], "original_file_name");
        String filename = objects[0].getPropertyObject("original_file_name").getStringValue();
        GetFileResponse getFileResponse = fmu.getFiles(objects);
        File[] fileinfovec = getFileResponse.getFiles();
        fmu.term();
        if (CommonlyUtils.isEmptyArray(fileinfovec)) throw new FileNotFoundException("数据集命名引用不存在!!!");
//        String path = changeFileName(fileinfovec[0],filename);
        File newFile = changeFileName2(fileinfovec[0],filename);
        return newFile;
    }

    public static String changeFileName(File file, String name) throws InterruptedException {
        String path = file.getParent() + "\\" + name;
        File directory = new File(path);
        if (directory.exists()){
            directory.delete();
        }
        if (file.getName().equals(name)) return path;
        int num = 0;
        while (num < 1) {
            boolean isChange = file.renameTo(new File(path));
            if (isChange) break;
            else {
                LogUtil.info(TCUtils.class,"修改文件名称失败，等待1秒！");
                Thread.sleep(1000);
            }
            num++;
        }
        return path;
    }

    public static File changeFileName2(File file, String name) throws Exception{
        File newFile = FileUtil.rename(file,name,true);
        return newFile;
    }

    public static String checkFileName(String name) {
        return name.replaceAll("/","_")
                .replaceAll("\\|","_")
                .replaceAll("\\\\","_")
                .replaceAll("\"","_")
                .replaceAll(":","_")
                .replaceAll("\\*","_")
                .replaceAll("\\?","_")
                .replaceAll("<","_")
                .replaceAll(">","_");
    }

    // 文件转ByteArrayOutputStream字符串
    public static String fileToString(File file) throws IOException {
        if (file == null) return null;
        InputStream in = new FileInputStream(file);
        int len = 0;
        byte[] buffer = new byte[1024];
        ByteArrayOutputStream out = new ByteArrayOutputStream();
        while ((len = in.read(buffer)) > 0) {
            out.write(buffer, 0, len);
        }
        String str = out.toString();
        in.close();
        return str;
    }

    //file转Base64字符串
    public static String fileToBase64(String filePath) throws IOException {
        if (CommonlyUtils.isEmpty(filePath)) return null;
        byte[] b = Files.readAllBytes(Paths.get(filePath));
        return Base64.getEncoder().encodeToString(b);
    }

    public static boolean isReleased(AppXSession session, ModelObject object) throws NotLoadedException {
        TCUtils.setModelObjectValue(session,object,"release_status_list");
        ModelObject[] status = object.getPropertyObject("release_status_list").getModelObjectArrayValue();
        if (CommonlyUtils.isEmpty(status)) return false;
        return true;
    }


    //通过HttpServletResponse传递文件的输出流
    public static void httpResponseFile(File file, HttpServletResponse response) throws IOException {
        if (file == null) return;
        String realPath = file.getAbsolutePath();
        String fileName = realPath.substring(realPath.lastIndexOf("\\") + 1);
        //3.设置content-disposition响应头控制浏览器以下载的形式打开文件
        fileName = URLEncoder.encode(fileName, "UTF-8");
        response.setHeader("content-disposition", "attachment;filename=" + fileName.replaceAll("\\+",
                "%20"));
        InputStream in = new FileInputStream(realPath);
        int len = 0;
        byte[] buffer = new byte[1024];
        ByteArrayOutputStream out = new ByteArrayOutputStream();
        while ((len = in.read(buffer)) > 0) {
            out.write(buffer, 0, len);
        }
        in.close();
    }

    //创建流程
    public static EPMTask createWorkflow(AppXSession session, WorkflowInfo workflowInfo) throws Exception {
        WorkflowService workflowService = WorkflowService.getService(session.getConnection());
        List<ModelObject> mlist = workflowInfo.getWorkflowTargets();
        String workflowTempName = workflowInfo.getWorkflowTempName();
        String workflowName = workflowInfo.getWorkflowName();
        int number = mlist.size();
        if (number == 0) throw new Exception("流程目标对象不能为空！！!");
        String subject = "";
        String observerKey = "";
        Workflow.ContextData contextData = new Workflow.ContextData();
        contextData.attachmentCount = number; //流程目标数量
        contextData.attachments = new String[number];   //流程目标
        contextData.attachmentTypes = new int[number];  //流程类型：目标或者引用
        for (int i = 0; i < number; i++) {
            ModelObject obj = mlist.get(i);
            contextData.attachments[i] = obj.getUid();
            contextData.attachmentTypes[i] = 1;
        }
        contextData.subscribeToEvents = false;
        contextData.subscriptionEventCount = 0;
        contextData.processTemplate = workflowTempName;
        Workflow.InstanceInfo resp = workflowService.createInstance(false, observerKey, workflowName,
                subject, "", contextData);
        checkPartialErrors(resp.serviceData);
        Job job = (Job) resp.serviceData.getCreatedObject(0);
        setModelObjectValue(session, job, "root_task");
        EPMTask task = job.get_root_task();
        return task;
    }

    //判断是否错误
    public static ErrorStack checkPartialError(ServiceData servicedata) {
        if (servicedata.sizeOfPartialErrors() > 0)
            return servicedata.getPartialError(0);
        else
            return null;
    }

    //显示报错
    public static String displayErrors(ServiceData serviceData) {
        StringBuffer buf = new StringBuffer();
        for (int x = 0; x < serviceData.sizeOfPartialErrors(); ++x) {
            String[] messages = serviceData.getPartialError(x).getMessages();
            for (int y = 0; y < messages.length; ++y) {
                buf.append(messages[y]);
                buf.append("\n");
            }
        }
        String errorMessage = buf.toString();
        return errorMessage;
    }

    public static void checkPartialErrors(ServiceData serviceData) throws Exception {
        StringBuffer buf = new StringBuffer();
        for (int x = 0; x < serviceData.sizeOfPartialErrors(); ++x) {
            String[] messages = serviceData.getPartialError(x).getMessages();
            for (int y = 0; y < messages.length; ++y) {
                buf.append(messages[y]);
                buf.append("\n");
            }
        }
        if (buf.length() > 0) throw new Exception(buf.toString());
    }

    /**
     * 搭建关系
     *
     * @param session
     * @param parent
     * @param child
     * @param relation
     * @throws Exception
     */
    public static void createRelation(AppXSession session, ModelObject parent, ModelObject child, String relation)
            throws Exception {
        DataManagementService dMService = DataManagementService.getService(session.getConnection());
        com.teamcenter.services.strong.core._2006_03.DataManagement.Relationship relationship =
                new com.teamcenter.services.strong.core._2006_03.DataManagement.Relationship();
        relationship.clientId = "addReleation";
        relationship.relationType = relation;
        relationship.primaryObject = parent;
        relationship.secondaryObject = child;
        com.teamcenter.services.strong.core._2006_03.DataManagement.CreateRelationsResponse response
                = dMService.createRelations(
                new com.teamcenter.services.strong.core._2006_03.DataManagement.Relationship[]{relationship});
        checkPartialErrors(response.serviceData);
    }

    /**替换数据集文件
     *
     * @param session
     * @param dataset
     * @param file
     * @param reference
     * @return
     * @throws Exception
     */
    public static Boolean updateDatasetSingleFile(AppXSession session, Dataset dataset, File file,
                                                  String reference) throws Exception {
        if (CommonlyUtils.isEmpty(dataset)) return null;
        TCUtils.setModelObjectValue(session, dataset, "ref_list");
        ModelObject[] objects = dataset.get_ref_list();
        TCUtils.setModelObjectValue(session, objects[0], "original_file_name");
        String filename = objects[0].getPropertyObject("original_file_name").getStringValue();
//        String newPath = TCUtils.changeFileName(file,filename);
//        File newFile = new File(newPath);
        File newFile = changeFileName2(file,filename);
        FileManagementUtility fMSFileManagement = new FileManagementUtility(session.getConnection(),
                null,
                new String[]{SpringbootJjwtApplication.TC_FMSURL},
                new String[]{SpringbootJjwtApplication.TC_FMSURL},
                SpringbootJjwtApplication.TC_FCCCACH);
        FileManagement.DatasetFileInfo fileInfo = new FileManagement.DatasetFileInfo();
        fileInfo.fileName            = newFile.getAbsolutePath();
        fileInfo.namedReferencedName = reference;
        fileInfo.isText              = false;
        fileInfo.allowReplace        = true;
        FileManagement.GetDatasetWriteTicketsInputData input = new FileManagement.GetDatasetWriteTicketsInputData();
        input.dataset = dataset;
        input.createNewVersion = false;
        input.datasetFileInfos = new FileManagement.DatasetFileInfo[]{fileInfo};
        ServiceData serviceData = fMSFileManagement.putFiles(new FileManagement.GetDatasetWriteTicketsInputData[]{input});
        checkPartialErrors(serviceData);
        newFile.delete();
        return true;
    }

    /**创建数据集
     *
     * @param
     * @param parent        父对象
     * @param relationType  父对象引用关系
     * @param file          文件
     * @param datasetName   数据集名称
     * @param fileType      文件类型
     * @param toolType      工具类型
     * @param reference     数据集引用
     * @return
     * @throws Exception
     */
    public static Dataset createNewDatasetAndUploadSingleFile(AppXSession session,ModelObject parent,String relationType,
                                                              File file, String datasetName, String fileType, String toolType,
                                                              String reference) throws Exception {
        DataManagementService dMService = DataManagementService.getService(session.getConnection());
        FileManagementUtility fMSFileManagement = new FileManagementUtility(AppXSession.getConnection(),
                null,
                new String[]{SpringbootJjwtApplication.TC_FMSURL},
                new String[]{SpringbootJjwtApplication.TC_FMSURL},
                SpringbootJjwtApplication.TC_FCCCACH);
        com.teamcenter.services.strong.core._2008_06.DataManagement.DatasetProperties2 props
                = new com.teamcenter.services.strong.core._2008_06.DataManagement.DatasetProperties2();
        props.clientId = "datasetWriteTixTestClientId";
        props.type = fileType;
        props.name = datasetName;
        props.description = "";
        props.toolUsed = toolType;
        props.container = parent;
        props.relationType = relationType;
        com.teamcenter.services.strong.core._2006_03.DataManagement.CreateDatasetsResponse resp
                =  dMService.createDatasets2(
                        new com.teamcenter.services.strong.core._2008_06.DataManagement.DatasetProperties2[]{props});
        checkPartialErrors(resp.serviceData);

        FileManagement.DatasetFileInfo fileInfo = new FileManagement.DatasetFileInfo();
        fileInfo.clientId            = "file";
        fileInfo.fileName            = file.getAbsolutePath();
        fileInfo.namedReferencedName = reference;
        fileInfo.isText              = false;
        fileInfo.allowReplace        = true;

        FileManagement.GetDatasetWriteTicketsInputData input = new FileManagement.GetDatasetWriteTicketsInputData();
        input.dataset = resp.output[0].dataset;
        input.createNewVersion = false;
        input.datasetFileInfos = new FileManagement.DatasetFileInfo[]{fileInfo};

        ServiceData serviceData = fMSFileManagement.putFiles(new FileManagement.GetDatasetWriteTicketsInputData[]{input});
        checkPartialErrors(serviceData);

        if (input != null) {
            LogUtil.info(TCUtils.class,"创建数据集的PUID为：" + input.dataset.getUid());
            return (Dataset) input.dataset;
        }
        throw new Exception("创建数据集失败!!!");
    }


    /**创建文件夹
     *
     * @param session
     * @param parent
     * @param relationType
     * @param folderName
     * @return
     * @throws Exception
     */
    public static Folder createNewFolder(AppXSession session,ModelObject parent,String relationType, String folderName)
            throws Exception {
        DataManagementService dMService = DataManagementService.getService(session.getConnection());
        com.teamcenter.services.strong.core._2006_03.DataManagement.CreateFolderInput createFolderInput =
                new com.teamcenter.services.strong.core._2006_03.DataManagement.CreateFolderInput();
        createFolderInput.clientId = "createFolder";
        createFolderInput.name = folderName;
        createFolderInput.desc = "";
        com.teamcenter.services.strong.core._2006_03.DataManagement.CreateFoldersResponse response
                = dMService.createFolders(new com.teamcenter.services.strong.core._2006_03.DataManagement.CreateFolderInput[]{
                        createFolderInput},parent,relationType);
        checkPartialErrors(response.serviceData);
        com.teamcenter.services.strong.core._2006_03.DataManagement.CreateFoldersOutput[] outputs = response.output;
        if (!CommonlyUtils.isEmptyArray(outputs)) {
            LogUtil.info(TCUtils.class,"创建文件夹的PUID为：" + outputs[0].folder.getUid());
            return outputs[0].folder;
        }
        throw new Exception("创建文件夹失败!!!");
    }

    /**创建对象
     *
     * @param session
     * @param itemID
     * @param itemRev
     * @param itemType
     * @param itemName
     * @param itemDesc
     * @param iteminfoList
     * @param revinfoList
     * @param revMasterinfoList
     * @return
     * @throws Exception
     */
    public static ModelObject createNewItem(AppXSession session, String itemID, String itemRev, String itemType,
                                            String itemName, String itemDesc, List<ConfigInfo> iteminfoList,
                                            List<ConfigInfo> revinfoList, List<ConfigInfo> revMasterinfoList)
            throws Exception {
        com.teamcenter.services.strong.core._2008_06.DataManagement.CreateInput itemInput
                = new com.teamcenter.services.strong.core._2008_06.DataManagement.CreateInput();
        itemInput.boName = itemType;
        Map<String, String> itemStringMap = new HashMap();
        itemStringMap.put("object_name", itemName);
        itemStringMap.put("item_id", itemID);
        itemStringMap.put("object_desc", itemDesc);
        if (CommonlyUtils.isEmptyList(iteminfoList)) itemInput.stringProps = itemStringMap;
        else setPropMapping(itemInput,iteminfoList,itemStringMap);
        Map<String, com.teamcenter.services.strong.core._2008_06.DataManagement.CreateInput[]> revMap = new HashMap();
        com.teamcenter.services.strong.core._2008_06.DataManagement.CreateInput[] compInputS
                = new com.teamcenter.services.strong.core._2008_06.DataManagement.CreateInput[1];
        compInputS[0] = new com.teamcenter.services.strong.core._2008_06.DataManagement.CreateInput();
        Map<String, String> revStringMap = new HashMap();
        revStringMap.put("item_revision_id", itemRev);
        compInputS[0].boName = itemType + "Revision";
        if (CommonlyUtils.isEmptyList(revinfoList)) compInputS[0].stringProps = revStringMap;
        else setPropMapping(compInputS[0], revinfoList, revStringMap);
        com.teamcenter.services.strong.core._2008_06.DataManagement.CreateInput[] formCompInputS
                = new com.teamcenter.services.strong.core._2008_06.DataManagement.CreateInput[1];
        formCompInputS[0] = new com.teamcenter.services.strong.core._2008_06.DataManagement.CreateInput();
        formCompInputS[0].boName = itemType + "RevisionMaster";
        if (!CommonlyUtils.isEmptyList(revMasterinfoList)) setPropMapping(formCompInputS[0],revMasterinfoList,null);
        Map<String, com.teamcenter.services.strong.core._2008_06.DataManagement.CreateInput[]> formCompMap = new HashMap();
        formCompMap.put("IMAN_master_form_rev", formCompInputS);
        compInputS[0].compoundCreateInput = formCompMap;
        revMap.put("revision", compInputS);
        itemInput.compoundCreateInput = revMap;
        DataManagementService dMService = DataManagementService.getService(session.getConnection());
        com.teamcenter.services.strong.core._2008_06.DataManagement.CreateIn createin
                = new com.teamcenter.services.strong.core._2008_06.DataManagement.CreateIn();
        createin.clientId = "create";
        createin.data = itemInput;
        com.teamcenter.services.strong.core._2008_06.DataManagement.CreateResponse createresponse = dMService
                .createObjects(
                        new com.teamcenter.services.strong.core._2008_06.DataManagement.CreateIn[] { createin });
        checkPartialErrors(createresponse.serviceData);
        com.teamcenter.services.strong.core._2008_06.DataManagement.CreateOut acreateout[] = createresponse.output;
        if (!CommonlyUtils.isEmptyArray(acreateout)) {
            LogUtil.info(TCUtils.class,"创建对象的PUID为：" + acreateout[0].objects[0].getUid());
            return acreateout[0].objects[0];
        }
        throw new Exception("创建对象失败!!!");
    }

    /**
     * 设置对象的属性匹配
     *
     * @param createInput
     */
    private static void setPropMapping(com.teamcenter.services.strong.core._2008_06.DataManagement.CreateInput createInput,
                                List<ConfigInfo> infoList, Map<String, String> map) {
        if (CommonlyUtils.isEmptyList(infoList)) return;
        Map<String, String> stringMapping = new HashMap<>();
        if (!CommonlyUtils.isEmptyMap(map)) {
            for (Map.Entry<String, String> entry : map.entrySet()) {
                if (!CommonlyUtils.isEmpty(entry.getValue())) stringMapping.put(entry.getKey(), entry.getValue());
            }
        }
        Map<String, String[]> stringArrayMapping = new HashMap<>();
        Map<String, BigInteger> intMapping = new HashMap<>();
        Map<String, Calendar> dateMapping = new HashMap<>();
        Map<String, Boolean> booleanMapping = new HashMap<>();
        Map<String, Double> doubleMapping = new HashMap<>();
        for (ConfigInfo configInfo : infoList) {
            if ("item_id".equals(configInfo.getTcname())) continue;
            Object obj = "".equals(configInfo.getValue()) ? null : configInfo.getValue();
            List<String> objs = configInfo.getObjs();
            switch (configInfo.getPropType().toUpperCase()) {
                case "STRING":
                    if (!CommonlyUtils.isEmpty(obj)) stringMapping.put(configInfo.getTcname(), (String) (obj));
                    break;
                case "INTEGER":
                    if (!CommonlyUtils.isEmpty(obj)) {
                        BigInteger bigin = BigInteger.valueOf(((Integer) obj).intValue());
                        intMapping.put(configInfo.getTcname(), bigin);
                    }
                    break;
                case "DATE":
                    if (!CommonlyUtils.isEmpty(obj)) dateMapping.put(configInfo.getTcname(), (Calendar) obj);
                    break;
                case "BOOLEAN":
                    if (!CommonlyUtils.isEmpty(obj)) booleanMapping.put(configInfo.getTcname(), (Boolean) obj);
                    break;
                case "DOUBLE":
                    if (!CommonlyUtils.isEmpty(obj)) doubleMapping.put(configInfo.getTcname(), (Double) obj);
                    break;
                case "ARRAY":
                    if (!CommonlyUtils.isEmptyList(objs)) stringArrayMapping.put(configInfo.getTcname(),
                            objs.toArray(new String[] {}));
                    break;
                default:
                    break;
            }
        }
        createInput.stringArrayProps = stringArrayMapping;
        createInput.stringProps = stringMapping;
        createInput.intProps = intMapping;
        createInput.dateProps = dateMapping;
        createInput.boolProps = booleanMapping;
        createInput.doubleProps = doubleMapping;
    }

    /**
     *
     * @param object    对象
     * @param valueMap  属性值
     * @param str
     * @throws Exception
     */
    public static void setProperty(AppXSession session, ModelObject object,Map<String,String> valueMap,String str)
            throws Exception{
        DataManagementService dMService = DataManagementService.getService(session.getConnection());
        int size = valueMap.size();
        int num = 0;
        com.teamcenter.services.strong.core._2010_09.DataManagement.PropInfo[] propInfos
                = new com.teamcenter.services.strong.core._2010_09.DataManagement.PropInfo[size];
        for (Map.Entry<String,String> map : valueMap.entrySet()) {
            com.teamcenter.services.strong.core._2010_09.DataManagement.NameValueStruct1[] vecNameVal
                    = new com.teamcenter.services.strong.core._2010_09.DataManagement.NameValueStruct1[0];
            vecNameVal[0] = new com.teamcenter.services.strong.core._2010_09.DataManagement.NameValueStruct1();
            propInfos[num] = new com.teamcenter.services.strong.core._2010_09.DataManagement.PropInfo();
            vecNameVal[0].name = map.getKey();
            vecNameVal[0].values = new String[]{map.getValue()};
            propInfos[num].object = object;
            propInfos[num].vecNameVal = vecNameVal;
        }
        com.teamcenter.services.strong.core._2010_09.DataManagement.SetPropertyResponse response
                = dMService.setProperties(propInfos,new String[]{str});
        checkPartialErrors(response.data);
    }

    /**
     * @param session
     * @param valueMap
     * @param str
     * @throws Exception
     */
    public static void setStringProperties(AppXSession session, Map<ModelObject,List<ConfigInfo>> valueMap, String str)
            throws Exception{
        List<ModelObject> list = new ArrayList<>();
        DataManagementService dMService = DataManagementService.getService(session.getConnection());
        int size = valueMap.size();
        int num = 0;
        com.teamcenter.services.strong.core._2010_09.DataManagement.PropInfo[] propInfos
                = new com.teamcenter.services.strong.core._2010_09.DataManagement.PropInfo[size];
        for (Map.Entry<ModelObject,List<ConfigInfo>> map : valueMap.entrySet()) {
            List<ConfigInfo> propList = map.getValue();
            int s = propList.size();
            if (s == 0) continue;
            com.teamcenter.services.strong.core._2010_09.DataManagement.NameValueStruct1[] vecNameVal
                    = new com.teamcenter.services.strong.core._2010_09.DataManagement.NameValueStruct1[s];
            for (int i = 0; i < s; i++) {
                vecNameVal[i] = new com.teamcenter.services.strong.core._2010_09.DataManagement.NameValueStruct1();
                vecNameVal[i].name = propList.get(i).getTcname();
                if (ConfigeType.ARRAYS.equals(propList.get(i).getPropType().toUpperCase()))
                    vecNameVal[i].values = propList.get(i).getObjs().toArray(new String[propList.size()]);
                else vecNameVal[i].values = new String[]{propList.get(i).getValue()};
            }
            if (CommonlyUtils.isEmptyArray(vecNameVal)) throw new Exception("数据不能为空！！！");
            propInfos[num] = new com.teamcenter.services.strong.core._2010_09.DataManagement.PropInfo();
            propInfos[num].object = map.getKey();
            list.add(map.getKey());
            propInfos[num].vecNameVal = vecNameVal;
            num++;
        }
        com.teamcenter.services.strong.core._2010_09.DataManagement.SetPropertyResponse response
                = dMService.setProperties(propInfos,new String[]{str});
        checkPartialErrors(response.data);
//        refresh(session,list.toArray(new ModelObject[]{}));
    }

    public static void refresh(AppXSession session, ModelObject[] modelObjects) {
        DataManagementService dMService = DataManagementService.getService(session.getConnection());
        dMService.refreshObjects(modelObjects);
    }

    public static void refresh(AppXSession session, ModelObject modelObjects) {
        refresh(session,new ModelObject[]{ modelObjects });
    }

    /**设置对象某个属性值
     *
     * @param session
     * @param object
     * @param prop
     * @param value
     * @throws Exception
     */
    public static void setStringProperty(AppXSession session, ModelObject object,String prop,String value)
            throws Exception{
        Map<String,String> map = new HashMap<>();
        map.put(prop,value);
        setStringProperty(session,object,map);
    }

    /**
     * 对象设置字符串属性
     * @param object    对象
     * @param valueMap  属性值
     * @throws Exception
     */
    public static void setStringProperty(AppXSession session, ModelObject object,Map<String,String> valueMap)
            throws Exception{
        DataManagementService dMService = DataManagementService.getService(session.getConnection());
        Map<String,DataManagement.VecStruct> vecStructMap = new HashMap<>();
        for (Map.Entry<String,String> map : valueMap.entrySet()) {
            DataManagement.VecStruct vecStruct = new DataManagement.VecStruct();
            vecStruct.stringVec = new String[]{ map.getValue() };
            vecStructMap.put(map.getKey(),vecStruct);
        }
        ServiceData serviceData = dMService.setProperties(new ModelObject[]{object},vecStructMap);
        checkPartialErrors(serviceData);
    }

    /**
     * 对象设置数组属性
     * @param object    对象
     * @param valueMap  属性值
     * @throws Exception
     */
    public static void setArrayProperty(AppXSession session, ModelObject object,Map<String,String[]> valueMap)
            throws Exception{
        DataManagementService dMService = DataManagementService.getService(session.getConnection());
        Map<String,DataManagement.VecStruct> vecStructMap = new HashMap<>();
        for (Map.Entry<String,String[]> map : valueMap.entrySet()) {
            DataManagement.VecStruct vecStruct = new DataManagement.VecStruct();
            vecStruct.stringVec = map.getValue();
            vecStructMap.put(map.getKey(),vecStruct);
        }
        ServiceData serviceData = dMService.setProperties(new ModelObject[]{object},vecStructMap);
        checkPartialErrors(serviceData);
    }

    //去除流程节点签发人员(仅限审核节点选择用户节点未完成的情况下)
//    public static void removeWorkflowNodeUser(AppXSession session, ItemRevision itemRev,String taskNodeName,
//                                              String workflowName) throws Exception {
//        WorkflowService workflowService = WorkflowService.getService(session.getConnection());
//        setModelObjectValue(session, itemRev,"process_stage_list");
//        ModelObject[] stageList = itemRev.get_process_stage_list();
//        if (CommonlyUtils.isEmpty(stageList)) throw new Exception("版本上的流程为空！！！");
//        setModelObjectValue(session,stageList,workflowprops);
//        ModelObject[] tasks = null;
//        for (ModelObject obj : stageList) {
//            String name = obj.getPropertyObject("object_name").getStringValue();
//            if (workflowName.equals(name)) {
//                tasks = ((EPMTask)obj).get_child_tasks();
//            }
//        }
//        if (tasks == null)  throw new Exception("未找到进行中的流程!!!");
//        Workflow.RemoveSignoffsInfo[] removeSignoffsInfos = new Workflow.RemoveSignoffsInfo[1];
//        Workflow.RemoveSignoffsInfo removeSignoffsInfo = new Workflow.RemoveSignoffsInfo();
//        setModelObjectValue(session,tasks,workflowprops);
//        for (ModelObject childtask : tasks) {
//            EPMTask nodetask = (EPMTask)childtask;
//            String taskstatus = nodetask.get_task_result();
//            String taskname = nodetask.get_object_name();
//            if (taskname.equals(taskNodeName) && Status.UNSET.equals(taskstatus)) {
//                ModelObject[] objs = nodetask.get_valid_signoffs();
//                if (CommonlyUtils.isEmpty(objs)) {
//                    System.out.println("节点："+ taskNodeName +"不存在有效签发");
//                    return;
//                }
//                Signoff[] signoffs = new Signoff[objs.length];
//                for (int i = 0 ; i < objs.length; i++) {
//                    signoffs[i] = (Signoff)objs[i];
//                }
//                removeSignoffsInfo.removeSignoffObjs = signoffs;
//                removeSignoffsInfo.task = nodetask;
//                removeSignoffsInfos[0] = removeSignoffsInfo;
//                ServiceData serviceData = workflowService.removeSignoffs(removeSignoffsInfos);
//                checkPartialErrors(serviceData);
//                break;
//            }
//        }
//    }

    private static boolean ErrorStackError(final ErrorStack err) {
        if(err.getMessages().length > 0) {
            for(String msg : err.getMessages())
                System.out.println(msg);
            return true;
        }
        return false;
    }

    private static boolean ServiceDataError(final ServiceData data) {
        if(data.sizeOfPartialErrors() > 0){
            for(int i = 0; i < data.sizeOfPartialErrors(); i++){
                for(String msg : data.getPartialError(i).getMessages())
                    LogUtil.error(TCUtils.class,msg);
            }
            return true;
        }
        return false;
    }

    //修改所有权
    public static void changeOwnershipModelObject(AppXSession session, ModelObject user, ModelObject[] modls)
            throws Exception {
        if (CommonlyUtils.isEmpty(modls)) return;
        DataManagementService dMService = DataManagementService.getService(session.getConnection());
        if( user != null ) {
            System.out.println("................................owning user found..................................");
        } else {
            //The configured EPI-Owning-user is not found in Teamcenter.
            System.out.println("................  EPI-owning user not found ................");
            throw new Exception("Change ownership service: 003.Change ownership service - " +
                    "The configured EPI-owning user is not found in Teamcenter.");
        }
        setModelObjectValue(session, user,"default_group");
        ModelObject userGroup = user.getPropertyObject("default_group").getModelObjectValue();
        if( userGroup != null ) {
            System.out.println("................................owning group found..................................");
        }else{
            System.out.println("................  EPI-owning group not found ................");
            throw new Exception("Change ownership service: 004.Change ownership service -" +
                    " The configured EPI-owning group is not found in Teamcenter.");
        }
        com.teamcenter.services.strong.core._2006_03.DataManagement.ObjectOwner[] ownerData
                = new com.teamcenter.services.strong.core._2006_03.DataManagement.ObjectOwner[modls.length];
        for(int i = 0 ; i <modls.length ;i++) {
            com.teamcenter.services.strong.core._2006_03.DataManagement.ObjectOwner ownrObj
                    = new com.teamcenter.services.strong.core._2006_03.DataManagement.ObjectOwner();
            ownrObj.object = modls[i];
            ownrObj.group = (Group) userGroup;
            ownrObj.owner = (User) user;
            ownerData[i] = ownrObj;
        }
        ServiceData returnData = dMService.changeOwnership(ownerData);
        checkPartialErrors(returnData);
    }

    public static void changeOwnershipModelObject(AppXSession session, ModelObject user, ModelObject modls)
            throws Exception {
        changeOwnershipModelObject(session, user,new ModelObject[]{modls});
    }

    public static void moveInFolder(AppXSession session, Folder folder,ModelObject modelObject) {
        moveInFolder(session,folder,new ModelObject[]{modelObject});
    }

    //拷贝移动
    public static void moveInFolder(AppXSession session, Folder folder,ModelObject[] modelObject) {
        DataManagementService dMService = DataManagementService.getService(session.getConnection());
        com.teamcenter.services.strong.core._2007_01.DataManagement.MoveToNewFolderInfo moveToNewFolderInfo
                = new com.teamcenter.services.strong.core._2007_01.DataManagement.MoveToNewFolderInfo();
        moveToNewFolderInfo.newFolder = folder;
        moveToNewFolderInfo.objectsToMove = modelObject;
        dMService.moveToNewFolder(new com.teamcenter.services.strong.core._2007_01.DataManagement.MoveToNewFolderInfo[]{
                moveToNewFolderInfo});
    }

    //通过id获取member
    public static GroupMember findGroupMember(AppXSession session, String userId) throws ServiceException {
        SavedQueryService queryService = SavedQueryService.getService(session.getConnection());
        DataManagementService dMService = DataManagementService.getService(session.getConnection());
        ImanQuery query = null;
        GroupMember groupMember = null;
        SavedQuery.GetSavedQueriesResponse savedQueries = queryService.getSavedQueries();
        if (savedQueries.queries.length == 0) {
            System.out.println("There are no saved queries in the system.");
            return groupMember;
        }
        for (int i = 0; i < savedQueries.queries.length; i++) {
            if (savedQueries.queries[i].name.equals("__EINT_group_members")) {
                query = savedQueries.queries[i].query;
                break;
            }
        }
        if (query == null) {
            System.out.println("There is not an '__EINT_group_members' query.");
            return groupMember;
        }
        try{
            com.teamcenter.services.strong.query._2008_06.SavedQuery.QueryInput savedQueryInput[]
                    = new com.teamcenter.services.strong.query._2008_06.SavedQuery.QueryInput[1];
            savedQueryInput[0] = new com.teamcenter.services.strong.query._2008_06.SavedQuery.QueryInput();
            savedQueryInput[0].query = query;
            savedQueryInput[0].entries = new String[1];
            savedQueryInput[0].values = new String[1];
            savedQueryInput[0].entries[0] = "User";
            savedQueryInput[0].values[0] = userId;
            savedQueryInput[0].maxNumToReturn = 25;
            com.teamcenter.services.strong.query._2007_09.SavedQuery.SavedQueriesResponse savedQueryResult
                    = queryService.executeSavedQueries(savedQueryInput);
            com.teamcenter.services.strong.query._2007_09.SavedQuery.QueryResults found
                    = savedQueryResult.arrayOfResults[0];
            int length = found.objectUIDS.length;
            String[] uids = new String[length];
            for( int ii = 0; ii < length; ii++) {
                uids[ii]= found.objectUIDS[ii];
            }
            ServiceData sd = dMService.loadObjects(uids);
            ModelObject[] foundObjs = new ModelObject[ sd.sizeOfPlainObjects()];
            for( int k =0; k< sd.sizeOfPlainObjects(); k++) {
                foundObjs[k] = sd.getPlainObject(k);
                groupMember = (GroupMember) foundObjs[k];
            }
            groupMember = (GroupMember) foundObjs[0];
        } catch (Exception e) {
            e.printStackTrace();
            System.out.println("ExecuteSavedQuery service request failed！！！");
        }
        return groupMember;
    }

    //通过组，角色，id获取member
    public static GroupMember findGroupMember(AppXSession session, String group, String role, String userId)
            throws ServiceException {
        SavedQueryService queryService = SavedQueryService.getService(session.getConnection());
        DataManagementService dMService = DataManagementService.getService(session.getConnection());
        ImanQuery query = null;
        GroupMember groupMember = null;
        try {
            SavedQuery.GetSavedQueriesResponse savedQueries = queryService.getSavedQueries();
            if (savedQueries.queries.length == 0) { //未找到
                System.out.println("There are no saved queries in the system.");
                return groupMember;
            }
            for (int i = 0; i < savedQueries.queries.length; i++) {
                if (savedQueries.queries[i].name.equals("__EINT_group_members")) {
                    query = savedQueries.queries[i].query;
                    break;
                }
            }
        } catch (ServiceException e) {
            System.out.println("GetSavedQueries service request failed.");
            System.out.println(e.getMessage());
            return groupMember;
        }
        if (query == null) {
            System.out.println("There is not an '__EINT_group_members' query.");
            return groupMember;
        }
        try{
            com.teamcenter.services.strong.query._2008_06.SavedQuery.QueryInput savedQueryInput[]
                    = new com.teamcenter.services.strong.query._2008_06.SavedQuery.QueryInput[1];
            savedQueryInput[0] = new com.teamcenter.services.strong.query._2008_06.SavedQuery.QueryInput();
            savedQueryInput[0].query = query;
            savedQueryInput[0].entries = new String[3];
            savedQueryInput[0].values = new String[3];
            savedQueryInput[0].entries[0] = "Group";
            savedQueryInput[0].values[0] = group;
            savedQueryInput[0].entries[1] = "Role";
            savedQueryInput[0].values[1] = role;
            savedQueryInput[0].entries[2] = "User";
            savedQueryInput[0].values[2] = userId;
            savedQueryInput[0].maxNumToReturn = 25;
            com.teamcenter.services.strong.query._2007_09.SavedQuery.SavedQueriesResponse savedQueryResult
                    = queryService.executeSavedQueries(savedQueryInput);
            com.teamcenter.services.strong.query._2007_09.SavedQuery.QueryResults found
                    = savedQueryResult.arrayOfResults[0];
            int length = found.objectUIDS.length;
            System.out.println("查找到的长度：" + length);
            String[] uids = new String[length];
            for( int ii = 0; ii < length; ii++) {
                uids[ii]= found.objectUIDS[ii];
            }
            ServiceData sd = dMService.loadObjects(uids);
            ModelObject[] foundObjs = new ModelObject[ sd.sizeOfPlainObjects()];
            for( int k =0; k< sd.sizeOfPlainObjects(); k++) {
                foundObjs[k] = sd.getPlainObject(k);
            }
            groupMember = (GroupMember) foundObjs[0];
        } catch (Exception e) {
            e.printStackTrace();
            System.out.println("ExecuteSavedQuery service request failed！！！");
        }
        return groupMember;
    }


    //搜索具体用户
    public static SearchResult searchUserById(String id) throws Exception{
        SearchResult searchResult = new SearchResult();
        String[] Key = {"User ID"};
        String[] Values = {id};
        ModelObject[] modelObjects = Query.queryItems("Admin - Employee Information",Key, Values);
        if (CommonlyUtils.isEmpty(modelObjects))  throw new Exception("TC中用户：" + id + "不存在！！！");
        else searchResult.setObj(modelObjects[0]);
        return searchResult;
    }

    //零组件具体ID及版本查询
    public static SearchResult searchItemByIdRev(String id,String rev){
        SearchResult searchResult = new SearchResult();
        String[] Key = {"Item ID","Revision"};
        String[] Values = {id,rev};
        ModelObject[] modelObjects = Query.queryItems("Item Revision...",Key, Values);
        if (CommonlyUtils.isEmpty(modelObjects)) searchResult.setMsg("PLM中：" + id + "/" + rev + "不存在！！！");
        else searchResult.setObj(modelObjects[0]);
        return searchResult;
    }

    //零组件具体ID查询
    public static SearchResult searchItemById(String id) throws Exception{
        SearchResult searchResult = new SearchResult();
        String[] Key = {"Item ID"};
        String[] Values = {id};
        ModelObject[] modelObjects = Query.queryItems("Item ID",Key, Values);
        if (CommonlyUtils.isEmpty(modelObjects)) return searchResult;
        else searchResult.setObj(modelObjects[0]);
        return searchResult;
    }
}
