package com.teamcenter.clientx;

import com.teamcenter.schemas.soa._2006_03.exceptions.ServiceException;
import com.teamcenter.services.strong.core.DataManagementService;
import com.teamcenter.services.strong.core._2006_03.DataManagement;
import com.teamcenter.services.strong.query.SavedQueryService;
import com.teamcenter.services.strong.query._2006_03.SavedQuery;
import com.teamcenter.soa.client.model.ModelObject;
import com.teamcenter.soa.client.model.ServiceData;
import com.teamcenter.soa.client.model.strong.Group;
import com.teamcenter.soa.client.model.strong.ImanQuery;
import com.teamcenter.soa.client.model.strong.User;

public class Utils {

    //Find user using User ID ->String user represent User ID
    public static ModelObject findUser(String user)

    {

        ImanQuery query = null;

        //SavedQueryService class is in package com.teamcenter.services.strong.query
        SavedQueryService queryService = SavedQueryService.getService(AppXSession.getConnection());
        try
        {
            SavedQuery.GetSavedQueriesResponse savedQueries = queryService.getSavedQueries();
            if (savedQueries.queries.length == 0)
            {
                return null;
            }
            for (int i = 0; i < savedQueries.queries.length; i++)
            {
                //__WEB_find_user -> Query in Query builder to find the user
                if (savedQueries.queries[i].name.equals("__WEB_find_user"))
                {
                    query = savedQueries.queries[i].query;
                    break;
                }

            }

        }
        catch (ServiceException e)
        {
            System.out.println(e.getMessage());
            return null;
        }
        if (query == null)
        {
            System.out.println("There is not an 'Item Name' query.");
            return null;
        }
        try
        {
            com.teamcenter.services.strong.query._2007_06.SavedQuery.SavedQueryInput savedQueryInput[] = new com.teamcenter.services.strong.query._2007_06.SavedQuery.SavedQueryInput[1];
            savedQueryInput[0] = new com.teamcenter.services.strong.query._2007_06.SavedQuery.SavedQueryInput();
            savedQueryInput[0].query = query;
            savedQueryInput[0].maxNumToReturn = 25;
            savedQueryInput[0].limitListCount = 0;
            savedQueryInput[0].limitList = new ModelObject[0];
            savedQueryInput[0].entries = new String[]{"User ID" };//Attribute in Query to search by
            savedQueryInput[0].values = new String[1];
            savedQueryInput[0].values[0] = user;//Value for the search attribute
            savedQueryInput[0].maxNumToInflate = 25;

            //Execute Query to find the User
            com.teamcenter.services.strong.query._2007_06.SavedQuery.ExecuteSavedQueriesResponse savedQueryResult = queryService.executeSavedQueries(savedQueryInput);
            com.teamcenter.services.strong.query._2007_06.SavedQuery.SavedQueryResults found = savedQueryResult.arrayOfResults[0];

            // System.out.println("Found Users:");

            ModelObject[] modelObjs = found.objects;

            return modelObjs[0]; //User object

        }
        catch (Exception e)
        {
            System.out.println(e.getMessage());
            return null;
        }

    }
    public static ModelObject findGroup(String groupName)
    {

        ImanQuery query = null;

        SavedQueryService queryService = SavedQueryService.getService(AppXSession.getConnection());

        try
        {

            SavedQuery.GetSavedQueriesResponse savedQueries = queryService.getSavedQueries();

            if (savedQueries.queries.length == 0)
            {
                return null;
            }

            for (int i = 0; i < savedQueries.queries.length; i++)
            {
                //__WEB_group -> Query in Query builder to find the group

                if (savedQueries.queries[i].name.equals("__WEB_group"))
                {
                    query = savedQueries.queries[i].query;
                    break;
                }

            }

        }
        catch (ServiceException e)
        {

            System.out.println(e.getMessage());
            return null;
        }

        if (query == null)
        {
            System.out.println("__WEB_group query not found");
            return null;
        }
        try
        {

            com.teamcenter.services.strong.query._2007_06.SavedQuery.SavedQueryInput savedQueryInput[] = new com.teamcenter.services.strong.query._2007_06.SavedQuery.SavedQueryInput[1];
            savedQueryInput[0] = new com.teamcenter.services.strong.query._2007_06.SavedQuery.SavedQueryInput();
            savedQueryInput[0].query = query;
            savedQueryInput[0].maxNumToReturn = 25;
            savedQueryInput[0].limitListCount = 0;
            savedQueryInput[0].limitList = new ModelObject[0];
            savedQueryInput[0].entries = new String[]{"Name" };//Attribute in Query to search by
            savedQueryInput[0].values = new String[1];
            savedQueryInput[0].values[0] = groupName;//Value for the search attribute
            savedQueryInput[0].maxNumToInflate = 25;

            //Execute Query to find the Group

            com.teamcenter.services.strong.query._2007_06.SavedQuery.ExecuteSavedQueriesResponse savedQueryResult = queryService.executeSavedQueries(savedQueryInput);

            com.teamcenter.services.strong.query._2007_06.SavedQuery.SavedQueryResults found = savedQueryResult.arrayOfResults[0];

            // System.out.println("Found Users:");


            ModelObject[] modelObjs = found.objects;

            return modelObjs[0];//Group object

        }
        catch (Exception e)
        {

            System.out.println(e.getMessage());

            return null;

        }

    }
    public static void changeOwnershipModelObject(ModelObject user, String groupName, ModelObject[] modls) throws Exception
    {
        DataManagementService ser1 = DataManagementService.getService( AppXSession.getConnection() );
        //ModelObject user  = findUser( userName ) ;

        if( user != null )
        {
            System.out.println("................................owning user found..................................");

        } else {


            //The configured EPI-Owning-user is not found in Teamcenter.

            System.out.println("................  EPI-owning user not found ................");

            throw new Exception("Change ownership service: 003.Change ownership service - The configured EPI-owning user is not found in Teamcenter.");

        }
        ModelObject userGroup = null;
        if(groupName!=""){
            userGroup  = findGroup( groupName ) ;
        }else{
            ser1.getProperties(new ModelObject[]{user},new String[]{"default_group"});
            userGroup = user.getPropertyObject("default_group").getModelObjectValue();
        }


        if( userGroup != null )
        {

            System.out.println("................................owning group found..................................");

        }else{

            System.out.println("................  EPI-owning group not found ................");

            throw new Exception("Change ownership service: 004.Change ownership service - The configured EPI-owning group is not found in Teamcenter.");

        }



        DataManagement.ObjectOwner[] ownerData = new DataManagement.ObjectOwner[modls.length];
        for(int i = 0 ; i <modls.length ;i++) {
            DataManagement.ObjectOwner ownrObj = new DataManagement.ObjectOwner();

            ownrObj.object = modls[i];
            ownrObj.group = (Group) userGroup;
            ownrObj.owner = (User) user;
            ownerData[i] = ownrObj;
        }
        ServiceData returnData = ser1.changeOwnership( ownerData );

        System.out.println( "****************************** Ownership changed successfully ******************************" );

        if(returnData.sizeOfPartialErrors() > 0){

            throw new Exception("Change ownership service: 005.Change ownership service - "+returnData.getPartialError(0).getMessages()[0]);

        }

    }
}
