import com.teamcenter.clientx.AppXSession;
import com.teamcenter.clientx.Query;
import com.teamcenter.services.strong.administration.IRMService;
import com.teamcenter.services.strong.administration._2006_03.IRM;
import com.teamcenter.services.strong.cad.StructureManagementService;
import com.teamcenter.services.strong.cad._2007_01.StructureManagement;
import com.teamcenter.services.strong.core.DataManagementService;
import com.teamcenter.services.strong.core.ReservationService;
import com.teamcenter.services.strong.core._2006_03.DataManagement;
import com.teamcenter.soa.client.model.ModelObject;
import com.teamcenter.soa.client.model.strong.*;

import java.io.Console;
import java.util.HashMap;

public class TestGetRevisionList {
    public static void main(String[] args) {

        if (args.length > 0)
        {
            if (args[0].equals("-help") || args[0].equals("-h"))
            {
                System.out.println("usage: java [-Dhost=http://server:port/tc] com.teamcenter.clientX.AppX");
                System.exit(0);
            }
        }

        // Get optional host information
        String serverHost = "http://10.10.172.37:7001/tc";
        String host = System.getProperty("host");
        if (host != null && host.length() > 0)
        {
            serverHost = host;
        }

        AppXSession session = new AppXSession(serverHost);

        try
        {

            User user = session.login();
//            getRevionAndBomView();
//            createFolderAndEdit(user);
//            checkOutAndCheckIn();
            getprivileges(user);
        }catch (Exception ex)
        {
            System.out.println( ex.getMessage());
            return ;

        }
        session.logout();
    }

    private static void getprivileges(User user) {
        try
        {
            DataManagementService dataManagementService = DataManagementService.getService(AppXSession.getConnection());
            StructureManagementService smService = StructureManagementService.getService( AppXSession.getConnection());
            //获取192685产品
            String[] Entries = {"Item ID"};
            String[] Values = {"20.01.007.00000010"};
            ModelObject[] modelObjects = Query.queryItems("Item ID",Entries, Values);
            dataManagementService.getProperties(modelObjects,new String[]{"item_id","object_name","item_revision","last_release_status","revision_list"});
            for(ModelObject modelObject : modelObjects) {
                Item item = (Item) modelObject;
                //获取最新发布的版本
                ItemRevision itemRevision = (ItemRevision) item.get_last_release_status();
                //若不存在 获取最新的版本
                if (itemRevision == null) {
                    ModelObject[] itemAllRevisions = item.get_revision_list();
                    itemRevision = (ItemRevision) itemAllRevisions[itemAllRevisions.length - 1];
                }
                //查询签出状态
//                itemRevision.get_checked_out();
//                ReservationService reservationService = ReservationService.getService(AppXSession.getConnection());
//                //签出
//                reservationService.checkout(new ModelObject[]{itemRevision},"","");
//                //签入
//                reservationService.checkin(new ModelObject[]{itemRevision});

                String[] privilegeNames = new String[] { "READ", "WRITE", "DELETE"};
                IRMService irmService = IRMService.getService(AppXSession.getConnection());
                IRM.CheckAccessorPrivilegesResponse resp = irmService.checkAccessorsPrivileges(user,new ModelObject[]{itemRevision}, privilegeNames);
                System.out.println("");
            }
        }catch (Exception ex)
        {
            System.out.println( ex.getMessage());
            return ;

        }
    }

    private static void checkOutAndCheckIn() {
        try
        {
            DataManagementService dataManagementService = DataManagementService.getService(AppXSession.getConnection());
            StructureManagementService smService = StructureManagementService.getService( AppXSession.getConnection());
            //获取192685产品
            String[] Entries = {"Item ID"};
            String[] Values = {"20.01.007.00000010"};
            ModelObject[] modelObjects = Query.queryItems("Item ID",Entries, Values);
            dataManagementService.getProperties(modelObjects,new String[]{"item_id","object_name","item_revision","last_release_status","revision_list"});
            for(ModelObject modelObject : modelObjects) {
                Item item = (Item) modelObject;
                //获取最新发布的版本
                ItemRevision itemRevision = (ItemRevision) item.get_last_release_status();
                //若不存在 获取最新的版本
                if (itemRevision == null) {
                    ModelObject[] itemAllRevisions = item.get_revision_list();
                    itemRevision = (ItemRevision) itemAllRevisions[itemAllRevisions.length - 1];
                }
//                查询签出状态
                itemRevision.get_checked_out();
                ReservationService reservationService = ReservationService.getService(AppXSession.getConnection());
                //签出
                reservationService.checkout(new ModelObject[]{itemRevision},"","");
                //签入
                reservationService.checkin(new ModelObject[]{itemRevision});
            }
        }catch (Exception ex)
        {
            System.out.println( ex.getMessage());
            return ;

        }
    }

    private static void createFolderAndEdit(User user) {
        try{
            //在Home创建文件夹
            Folder home = user.get_home_folder();
            DataManagementService dataManagementService = DataManagementService.getService(AppXSession.getConnection());
            DataManagement.CreateFolderInput createFolderInput = new DataManagement.CreateFolderInput();
            createFolderInput.name = "测试文件夹";
            DataManagement.CreateFoldersResponse createFoldersResponse =  dataManagementService.createFolders(new DataManagement.CreateFolderInput[]{createFolderInput},home,"");
            if(createFoldersResponse.serviceData.sizeOfCreatedObjects() == 0){
                System.out.println("创建失败");
                return;
            }
            //编辑文件夹属性
            Folder theNewFolder = createFoldersResponse.output[0].folder;
            com.teamcenter.services.strong.core._2007_01.DataManagement.VecStruct vecStruct = new com.teamcenter.services.strong.core._2007_01.DataManagement.VecStruct();
            vecStruct.stringVec = new String[]{"测试文件夹（修改后）"};
            HashMap<String, com.teamcenter.services.strong.core._2007_01.DataManagement.VecStruct> propertyMap = new HashMap<String, com.teamcenter.services.strong.core._2007_01.DataManagement.VecStruct>();
            //修改的属性和值
            propertyMap.put("object_name",vecStruct);
            dataManagementService.setProperties(new ModelObject[]{theNewFolder} , propertyMap );


        }catch (Exception ex)
        {
            System.out.println( ex.getMessage());
            return ;

        }


    }

    private static void getRevionAndBomView() {
        try
        {
            DataManagementService dataManagementService = DataManagementService.getService(AppXSession.getConnection());
            StructureManagementService smService = StructureManagementService.getService( AppXSession.getConnection());
            //获取192685产品
            String[] Entries = {"Item ID"};
            String[] Values = {"20.01.007.00000010"};
            ModelObject[] modelObjects = Query.queryItems("Item ID",Entries, Values);
            dataManagementService.getProperties(modelObjects,new String[]{"item_id","object_name","item_revision","last_release_status","revision_list"});
            for(ModelObject modelObject : modelObjects){
                Item item = (Item) modelObject;
                //获取最新发布的版本
                ItemRevision itemRevision = (ItemRevision) item.get_last_release_status();
                //若不存在 获取最新的版本
                if(itemRevision == null){
                    ModelObject[] itemAllRevisions = item.get_revision_list();
                    itemRevision = (ItemRevision) itemAllRevisions[itemAllRevisions.length-1];
                }
                //获取BOM
                StructureManagement.CreateBOMWindowsInfo[] createBOMWindowsInfo = new StructureManagement.CreateBOMWindowsInfo[1];
                createBOMWindowsInfo[0] = new StructureManagement.CreateBOMWindowsInfo();
                createBOMWindowsInfo[0].itemRev = itemRevision;
                StructureManagement.CreateBOMWindowsResponse createBOMWindowsResponse = smService.createBOMWindows(createBOMWindowsInfo);
                BOMLine topBomLine = (BOMLine) createBOMWindowsResponse.output[0].bomLine;
                dataManagementService.getProperties(new BOMLine[]{topBomLine},new String[]{"bl_child_lines"});
                ModelObject[] childrenBomLines =  topBomLine.get_bl_child_lines();




            }
        }catch (Exception ex)
        {
            System.out.println( ex.getMessage());
            return ;

        }
    }

    public static StructureManagement.CreateBOMWindowsResponse createBomWindow(ItemRevision itemRev)
    {
        StructureManagement.CreateBOMWindowsInfo[] createBOMWindowsInfo = new StructureManagement.CreateBOMWindowsInfo[1];
        createBOMWindowsInfo[0] = new StructureManagement.CreateBOMWindowsInfo();
        createBOMWindowsInfo[0].itemRev = itemRev;StructureManagementService smService = StructureManagementService.getService( AppXSession.getConnection() );;
        StructureManagement.CreateBOMWindowsResponse createBOMWindowsResponse = smService.createBOMWindows(createBOMWindowsInfo);
        return createBOMWindowsResponse;
    }
}
