package com.pjb.springbootjjwt;

import cn.hutool.poi.excel.ExcelReader;
import com.alibaba.fastjson.JSONObject;
import com.teamcenter.clientx.AppXSession;
import com.teamcenter.clientx.Query;
import com.teamcenter.schemas.soa._2006_03.exceptions.ServiceException;
import com.teamcenter.services.strong.cad.StructureManagementService;
import com.teamcenter.services.strong.cad._2007_01.StructureManagement;
import com.teamcenter.services.strong.classification.ClassificationService;
import com.teamcenter.services.strong.classification._2007_01.Classification;
import com.teamcenter.services.strong.core.DataManagementService;
import com.teamcenter.services.strong.core.FileManagementService;
import com.teamcenter.services.strong.core.SessionService;
import com.teamcenter.services.strong.core._2007_06.DataManagement;
import com.teamcenter.services.strong.core._2007_12.Session;
import com.teamcenter.soa.client.model.ModelObject;
import com.teamcenter.soa.client.model.ServiceData;
import com.teamcenter.soa.client.model.strong.*;
import com.teamcenter.soa.exceptions.NotLoadedException;
import org.apache.poi.ss.usermodel.Workbook;
import org.junit.Test;
import org.junit.runner.RunWith;
import org.springframework.boot.test.context.SpringBootTest;
import org.springframework.test.context.junit4.SpringRunner;

import java.io.*;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.*;

@RunWith(SpringRunner.class)
@SpringBootTest
public class SpringbootJjwtApplicationTests {

    private static AppXSession tcSession;
    private static User tcUser;
    private static SessionService sessionService;
    private static DataManagementService dataManagementService;
    private static StructureManagementService smService;
    private static StructureManagement.CreateBOMWindowsInfo[] createBOMWindowsInfo;
    private static FileManagementService fmService;
    private static ClassificationService classificationService;
    static {
        if(tcSession == null){
            tcSession = new AppXSession("http://connor:7001/tc");
        }
        try{
            if(tcUser == null) {
                tcUser = tcSession.login("admin","1","test");
            }
        }catch (Exception ex){
            ex.printStackTrace();
        }
        if (dataManagementService == null) {
            dataManagementService = DataManagementService.getService(tcSession.getConnection());
        }
        if (smService == null){
            smService = StructureManagementService.getService(tcSession.getConnection());
        }
        if (createBOMWindowsInfo == null) {
            createBOMWindowsInfo = new StructureManagement.CreateBOMWindowsInfo[1];
        }
        if (fmService == null){
            fmService = FileManagementService.getService(tcSession.getConnection());
        }
        if (classificationService == null){
            classificationService = ClassificationService.getService(tcSession.getConnection());
        }
        if (sessionService == null) {
            sessionService = SessionService.getService(tcSession.getConnection());
        }
    }

    @Test
    public void contextLoads() {
        try {
            ModelObject obj = getPUID("g_vJbkdKpRsZiB");
            ItemRevision rev = (ItemRevision) obj;
            dataManagementService.getProperties(new ModelObject[]{rev},new String[]{"release_status_list"});
            ModelObject[] status = new ModelObject[0];
            status = rev.get_release_status_list();
            if (status != null && status.length > 0) {
                ReleaseStatus statuses = (ReleaseStatus) status[0];
                dataManagementService.getProperties(new ModelObject[]{statuses},new String[]{"object_type","name",
                        "object_name","object_type"});
                System.out.println("name=" + statuses.get_name());
                System.out.println("object_name=" + statuses.get_object_name());
                System.out.println("object_type=" + statuses.get_object_type());
            }
        } catch (NotLoadedException e) {
            e.printStackTrace();
        }
    }

    private ModelObject getPUID(String str){
        return dataManagementService.loadObjects(new String[]{str}).getPlainObject(0);
    }


    private ModelObject getItem() {
        String[] key = {"Item ID"};
        String[] value = {"000438"};
        String searchName = "Item ID";
        ModelObject[] modelObjects = Query.queryItems(searchName,key,value);
        return modelObjects[0];
    }

    @Test
    public void  test01(){

        //测试Item的get_item_revision方法取到是哪个版本
        String [] prodpros = {"object_name","revision_list"};
        String[] revprops = {"item_revision_id","IMAN_classification"};
        String[] prop = {"cid"};
        String[] key = {"Item ID"};
        String[] value = {"000438"};
        String searchName = "Item ID";
        ModelObject[] modelObjects = Query.queryItems(searchName,key,value);
        Item prod = (Item) modelObjects[0];
        ItemRevision rev = null;
        dataManagementService.getProperties(new ModelObject[]{prod},prodpros);
        try {
            ModelObject[] mod = prod.get_revision_list();
            if (mod != null && mod.length > 0) {
                rev = (ItemRevision)mod[mod.length - 1];
            }
            dataManagementService.getProperties(new ModelObject[]{rev},revprops);
            ModelObject[] obj =  rev.get_IMAN_classification();
            dataManagementService.getProperties(obj,new String[] {"object_name"});
            Icm0 icm0 = (Icm0)obj[0];
            try {
                //根据Icm0获取对象
//                Classification.FindClassifiedObjectsResponse response1 = classificationService.findClassifiedObjects(new ModelObject[]{icm0});
                //根据Icm0获取到分类中的对象
                Classification.GetClassificationObjectsResponse response = classificationService.getClassificationObjects(new ModelObject[]{icm0});

                String classId = response.clsObjs.get(icm0).classId;
                //根据classid获取属性
                Classification.GetAttributesForClassesResponse response1 = classificationService.getAttributesForClasses(new String[] {classId});
                Map<String, Classification.ClassAttribute[]> attributes = response1.attributes;
                for (Map.Entry<String, Classification.ClassAttribute[]> attribute : attributes.entrySet()) {
                    System.out.println("key=>" + attribute.getKey());
                    Classification.ClassAttribute[] cas = attribute.getValue();
                    for (Classification.ClassAttribute ca : cas) {
                        System.out.println("id=>" + ca.id);
                        System.out.println("name=>" + ca.name);
                        System.out.println("options=>" + ca.options);
                    }
                }


//                System.out.println("response.clsObjs.classId==>" + response.clsObjs.get(icm0).classId);
//                ModelObject object  =response.clsObjs.get(icm0).clsObjTag;
//                System.out.println("response.clsObjs.getUid==>" + object.getUid());
//                Classification.ClassificationObject o = (Classification.ClassificationObject)object;
//                System.out.println("response.clsObjs.instanceId==>" + response.clsObjs.get(icm0).instanceId);
//                System.out.println("response.clsObjs.unitBase==>" + response.clsObjs.get(icm0).unitBase);
//                System.out.println("response.clsObjs.wsoId.getUid==>" + response.clsObjs.get(icm0).wsoId.getUid());
//                Classification.ClassificationProperty[] properties =  response.clsObjs.get(icm0).properties;
//                for (Classification.ClassificationProperty property : properties){
//                    System.out.println("属性ID==>" + property.attributeId);
//                    //根据classid获取属性
//                    System.out.println("属性Value长度==>" + property.values.length);
//                    if (property.values.length > 0) {
//                        System.out.println("属性displayValue==>" + property.values[0].displayValue);
//                        //这个是值
//                        System.out.println("属性dbValue==>" + property.values[0].dbValue);
//                    }
//                }
            } catch (ServiceException e) {
                e.printStackTrace();
            }
        } catch (NotLoadedException e) {
            e.printStackTrace();
        }
//        WorkspaceObject[] obj = new WorkspaceObject[]{prod};
//        DataManagement.WhereReferencedResponse response =  dataManagementService.whereReferenced(obj,3);
//        System.out.println("长度1===》" + response.output.length);
//        DataManagement.WhereReferencedInfo[] info =  response.output[0].info;
//        System.out.println("长度2===》" + info.length);
//        System.out.println("relation===》" + info[0].relation);
//        System.out.println("referencer===》" + info[0].referencer.getUid());
//        System.out.println("level===》" + info[0].level);
    }

    @Test
    public void test02(){
        String type = "HG8_DL02Form";
        JSONObject jsonObject = new JSONObject();
        FileInputStream fileInputStream = null;
        InputStream in = null;
        try {
            fileInputStream = new FileInputStream("D://123//大类清单配置.xlsx");
        } catch (FileNotFoundException e) {
            e.printStackTrace();
        }
        ExcelReader reader = new ExcelReader(fileInputStream,type);
        String type1 = reader.getSheet().getSheetName();
        System.out.println("sheet页数：" + reader.getSheetCount() + ",类型：" + type1);
        List<Object> props = reader.readColumn(0,1);
        for (Object str : props) {
            jsonObject.put(str.toString(),str);
        }
        System.out.println(jsonObject.toString());
    }

    @Test
    public void test03() throws NotLoadedException {
        String[] prop = {"bl_rev_object_type","bl_item_object_type"};
        String[] key = {"MateCode"};
        String[] value = {"9468127"};
        String searchName = "产品信息查询";
        ModelObject[] modelObjects = Query.queryItems(searchName,key,value);
        ItemRevision rev = (ItemRevision) modelObjects[0];
        createBOMWindowsInfo[0] = new StructureManagement.CreateBOMWindowsInfo();
        createBOMWindowsInfo[0].itemRev = rev;
        StructureManagement.CreateBOMWindowsResponse createBOMWindowsResponse = smService.createBOMWindows(createBOMWindowsInfo);
        BOMLine topBomLine = (BOMLine) createBOMWindowsResponse.output[0].bomLine;
        dataManagementService.getProperties(new BOMLine[]{topBomLine},new String[]{"bl_child_lines"});
        ModelObject[] childrenBomLines =  topBomLine.get_bl_child_lines();
        dataManagementService.getProperties(childrenBomLines,prop);
        if (childrenBomLines != null && childrenBomLines.length > 0) {
            String revtype =((BOMLine)childrenBomLines[0]).get_bl_rev_object_type();
            String itemtype =((BOMLine)childrenBomLines[0]).get_bl_item_object_type();
            System.out.println("版本类型==》" + revtype);
            System.out.println("对象类型==》" + itemtype);
        }
    }

    @Test
    public void test04(){

    }

    @Test
    public void test05(){
//        String[] key = {"date"};
        String[] key = {"Released After"};
//        String[] key = {"发布时间晚于"};
//        String[] value = {"2022-5-11 00:00"};
        String[] value = {"13-May-2022 13:45"};
//        String searchName = "产品时间查询";
//        String searchName = "Test";
        String searchName = "QueryCateBomByTime";
//        String searchName = "General...";
        ModelObject[] modelObjects = Query.queryItems(searchName,key,value);
        System.out.println("长度：" + modelObjects.length);
    }

    @Test
    public void test06() throws ParseException {
        String sdfStr = "d-MMM-yyyy HH:mm";
        String str = "2022-05-11 12:30:00";
        SimpleDateFormat format = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
        SimpleDateFormat sdf_en = new SimpleDateFormat(sdfStr, Locale.ENGLISH);
        String date = sdf_en.format(format.parse(str));
        System.out.println("date=" + date);
    }

    @Test
    public void test07() throws NotLoadedException {
        ModelObject obj = getPUID("QMkJs$aMpRsZiB");
        com.teamcenter.services.strong.core._2007_06.DataManagement.WhereReferencedByRelationNameInfo[] var1 = new com.teamcenter.services.strong.core._2007_06.DataManagement.WhereReferencedByRelationNameInfo[1];
        com.teamcenter.services.strong.core._2007_06.DataManagement.RelationAndTypesFilter[] filter = new com.teamcenter.services.strong.core._2007_06.DataManagement.RelationAndTypesFilter[1];
        System.out.println(filter[0]==null);
        System.out.println(var1[0]==null);
        filter[0] = new DataManagement.RelationAndTypesFilter();
        filter[0].relationTypeName = "HG8_MatchBOM2";
        filter[0].otherSideObjectTypes = new String[] {"HG8_ProductRevision"};
        var1[0] = new DataManagement.WhereReferencedByRelationNameInfo();
        var1[0].object = obj;
        var1[0].filter = filter;
        com.teamcenter.services.strong.core._2007_06.DataManagement.WhereReferencedByRelationNameResponse response =  dataManagementService.whereReferencedByRelationName(var1,1);
        com.teamcenter.services.strong.core._2007_06.DataManagement.WhereReferencedByRelationNameOutputInfo[] info =  response.output[0].info;
        for (int i = 0; i < info.length; i++) {
            ModelObject rev = info[i].referencer;
            dataManagementService.getProperties(new ModelObject[]{rev},new String[]{"object_type","object_name"});
            System.out.println("PUID=" + rev.getUid());
            System.out.println("object_type=" + rev.getPropertyObject("object_type").getStringValue());
            System.out.println("object_name=" + rev.getPropertyObject("object_type").getStringValue());
            System.out.println("relationTypeName=" + info[i].relationTypeName);
            System.out.println("level=" + info[i].level);
        }

    }

    @Test
    public void test09() {
        ModelObject obj =getPUID("hikJVVDvpRsZiB");
        Map<String,String> map = new HashMap<>();
        map.put("hg8_DrawNo","AAAAAAAAAAAAAA");
        try {
            setProperty(obj,map,null);
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    public static void setByPass(boolean b) throws Exception {
        com.teamcenter.services.strong.core._2007_12.Session.StateNameValue[] propPairs = new com.teamcenter.services.strong.core._2007_12.Session.StateNameValue[1];
        propPairs[0] = new Session.StateNameValue();
        propPairs[0].name = "bypassFlag";
        propPairs[0].value = com.teamcenter.soa.client.model.Property.toBooleanString(b);
        ServiceData data = sessionService.getService(AppXSession.getConnection()).setUserSessionState(propPairs);
        if(displayErrors(data).length() > 0){
            throw new Exception(b?"开启旁路失败！":"关闭旁路失败！");
        }
    }


    public static void setProperty(ModelObject object,Map<String,String> valueMap) throws Exception{
        Map<String, com.teamcenter.services.strong.core._2007_01.DataManagement.VecStruct> vecStructMap = new HashMap<>();
        for (Map.Entry<String,String> map : valueMap.entrySet()) {
            com.teamcenter.services.strong.core._2007_01.DataManagement.VecStruct vecStruct = new com.teamcenter.services.strong.core._2007_01.DataManagement.VecStruct();
            vecStruct.stringVec = new String[]{ map.getValue() };
            vecStructMap.put(map.getKey(),vecStruct);
        }
        setByPass(true);
        ServiceData serviceData = dataManagementService.setProperties(new ModelObject[]{object},vecStructMap);
        setByPass(false);
        if(displayErrors(serviceData).length() > 0){
            throw new Exception("设置属性发生错误！！！");
        }
    }

    //显示报错
    public static String displayErrors(ServiceData serviceData)
    {
        StringBuffer buf = new StringBuffer();
        for (int x = 0; x < serviceData.sizeOfPartialErrors(); ++x)
        {
            String[] messages = serviceData.getPartialError(x).getMessages();
            for (int y = 0; y < messages.length; ++y)
            {
                buf.append( messages[y] );
                buf.append( "\n" );
            }
        }
        String errorMessage = buf.toString();
        return errorMessage;
    }

    public static void setProperty(ModelObject object,Map<String,String> valueMap,String str) throws Exception{
        int size = valueMap.size();
        int num = 0;
        com.teamcenter.services.strong.core._2010_09.DataManagement.PropInfo[] propInfos = new com.teamcenter.services.strong.core._2010_09.DataManagement.PropInfo[size];
        for (Map.Entry<String,String> map : valueMap.entrySet()) {
            com.teamcenter.services.strong.core._2010_09.DataManagement.NameValueStruct1[] vecNameVal = new com.teamcenter.services.strong.core._2010_09.DataManagement.NameValueStruct1[1];
            vecNameVal[0] = new com.teamcenter.services.strong.core._2010_09.DataManagement.NameValueStruct1();
            propInfos[num] = new com.teamcenter.services.strong.core._2010_09.DataManagement.PropInfo();
            vecNameVal[0].name = map.getKey();
            vecNameVal[0].values = new String[]{map.getValue()};
            propInfos[num].object = object;
            propInfos[num].vecNameVal = vecNameVal;
        }
        setByPass(true);
        com.teamcenter.services.strong.core._2010_09.DataManagement.SetPropertyResponse response = dataManagementService.setProperties(propInfos,new String[]{str});
        setByPass(false);
        if(displayErrors(response.data).length() > 0){
            throw new Exception("设置属性2发生错误！！！");
        }
    }

    @Test
    public void TT() {
        tdd<String> t = new tdd<>();
        t.setT("22");
        System.out.println("t=" + t.getT());
    }


    @Test
    public void main() {
        int[] nums = {2,7,11,15};
        int target = 9;
        twoSum(nums,target);

    }

    private int getValue(String s,int max){
        List<Character> clist = new ArrayList<>();
        char[] cs = s.toCharArray();
        int size = 0;
        String s1 = "";
        for (char c : cs) {
            if (clist.contains(c)) {
                size = clist.size();
                max = size > max ? size : max;
                if (s.length() > 1){
                    s1 = s.substring(1);
                    max = getValue(s.substring(1),max);
                }
                return max;
            }
            clist.add(c);
        }
        return 0;
    }

    public int[] twoSum(int[] nums, int target) {
        for (int i = 0, len = nums.length; i < len; i++) {
            for (int j = 0; j < len; j++) {
                if (i != j && (nums[i] + nums[j]) == target){
                    return new int[]{i,j};
                }
            }
        }
        return null;
    }
}

class tdd<T> {
    private T t;

    public T getT() {
        return t;
    }

    public void setT(T t) {
        this.t = t;
    }

    public void opt() {

    }

}